; Copyright Formcroft Ltd 1997-1999
 .model small.486.code
 include always.inc; Assembler shorthands like 'Bptr' for 'byte ptr'.
 include declares.inc; Symbolic constants, macros, records, structures.
; The GROUP mechanism is capable of spreading the table of operation addresses
; amongst different assemblies but that is not now exploited - here are all
; the Pcode addresses.
; FanSeg is canned by a utility so not commented. See "Pcode generation".
MyGroup GROUP _TEXT, FanSeg
FanSeg SEGMENT WORD PUBLIC 'CODE'
PcodesBase$:
 dw Abut$$
 dw Cat$$
 dw Nop$$
 dw AssignDotsP$$
 dw Parse$$
 dw ResumeParse$$
 dw Number$$; After J in DO J=...
 dw To$$
 dw By$$
 dw For$$
 dw While$$
 dw Until$$
 dw IterRep$$; Matches DO 999
 dw Iterate$$; Matches DO FOREVER
 dw Leave$$
 dw UnDo$$
 dw Result$$
 dw Return$$
 dw Returns$$
 dw Exit$$
 dw Say$$
 dw Bifq$$
 dw Length$$
 dw Max$$
 dw Min$$
 dw Not$$
 dw And$$
 dw Or$$
 dw Xor$$
 dw Positive$$
 dw Negate$$
 dw Add$$
 dw Subtract$$
 dw Multiply$$
 dw Divide$$
 dw IntDivide$$
 dw Remainder$$
 dw Power$$
 dw Command$$
 dw Interpret$$
 dw Numeric$$
 dw Invoke$$
 dw Call$$
PjumpBase$:
 dw Rep$$; DO 999
 dw RepEver$$; DO FOREVER
 dw ControlVar$$; DO N=A TO B
BPcodesCeil$:
 dw DotControlVar$$
 dw Then$$
 dw When$$
 dw Jump$$
 dw Eq$$
 dw Ne$$
 dw Lt$$
 dw Le$$
 dw Ge$$
 dw Gt$$
 dw Seq$$
 dw Sne$$
 dw Slt$$
 dw Sle$$
 dw Sge$$
 dw Sgt$$
 dw Ceq$$
 dw Cne$$
 dw Clt$$
 dw Cle$$
 dw Cge$$
 dw Cgt$$
PjumpCeil$:
 dw InterpEnd$$
 dw Signal$$
 dw SignalOn$$
 dw CallOn$$
 dw Dots$$
 dw Assign$$
 dw AssignStem$$
 dw AssignDots$$
 dw AssignConst$$
 dw Unstore$$
 dw Drop$$
 dw Expose$$
 dw Bool$$
 dw IterCV$$
 dw Address$$
 dw CommandEnv$$
 dw EnvName$$
 dw Bif$$
 dw BifGroup$$
 dw Raise$$
 dw SignalOff$$
 dw SignalV$$
 dw SysVar$$
 dw DropList$$
 dw ExposeList$$
 dw Push$$
 dw Queue$$
 dw Trace$$
 dw TraceEvent$$
 dw Options$$
PcodesCeil$:
FanSeg ENDS

 EXTERN Bif$$:near,Bifq$$:near,BifGroup$$:near,Trace$$:near; With the Bif.
 EXTERN Max$$:near,Min$$:near,Length$$:near
 EXTERN Address$$:near,EnvName$$:near
 EXTERN Command$$:near,TraceEvent$$:near,TraceEventX:near
 EXTERN One$$:near,String1$$:near

 PUBLIC _Eq$$, _Ne$$, _Lt$$, _Le$$, _Ge$$, _Gt$$, _Seq$$, _Sne$$, _Slt$$
 PUBLIC Abut$$; Used by Command$$
 PUBLIC Interpret1; Used during initializing.
 PUBLIC AddRegs,CompareTO; Used in Bcode implementation.
 PUBLIC Exit, ExitDOS
 PUBLIC StrictFlags; Used at compile to test constants.

 PUBLIC Raise49
 PUBLIC Raise26p5,Raise26p6
 PUBLIC Raise33p1,Raise33p2,Raise33p3
 PUBLIC Raise34p5,Raise34p6
 PUBLIC Raise40
 PUBLIC Raise40p11,Raise40p32,Raise40p33

 EXTERN Bassign:near; This code does some work on behalf of Bcode.
; Things implemented in Bcode, run from here.
 EXTERN B4DROP:near,B4EXPOSE:near,ARITHOP$$:near,PATHQUALIFY:near
 EXTERN CloseBx:near; Needed by Exit.
 EXTERN MakeMsg:near
 EXTERN ShowMsg:near

CommandEnv$$:Error49Bp

Operator:inc CursorSixor bh,bh
; The fan-out is made with:
; AX not in use.
; BX containing the opcode (hence bh=0) and reusable.
; CX not in use. (See Note 1)
; DX not in use. (See Note 1)
; SI such that gs:CursorSi is after opcode. Return must be made with SI
; positioned on the next opcode.
; DI at the low address end of the latest operand to be stacked.
; DS not in use.
; ES not in use.
; FS addressing the current variables. Return must be with same value.
; GS addressing the Pcode. Return must be with same value.
; Note 1: Extensions of these registers are all not in use, except that
; when the top stack item is binary, it's value will be in ecx:edx as well
; on the stack.  (?? is this worth guaranteeing?)

if Debug
  push axmov ax,gscmp ax,Y.Csegjae @Fint 3@@:pop ax

  push axmov ax,escmp ax,Z.ProgScopeje @Fint 3@@:pop ax

  mov Z.DebugStash,bx
  Qry Z.Cancel,BcodeInterpretjz @Fmov Z.DebugStash,$pReturns@@:
endif

  mov Z.Stack,StackDi; Record of how much stack in use needed for Compaction.

; Jmps are faster than Rets so potentially fast to jump out to code and jump
; back (as is done for operand-to-stack loading) but that would prevent the
; functions from being (easily) called from other places.

  call cs:(PcodesBase$-1)[bx]

if Debug
; Part of check that StackDi = Z.CurrentDO at end-of-clause, ie no
; unprocessed operands left over.
if MemCheck
    call DosMemCheck
endif
 mov bx,Z.DebugStashcmp bl,$pReturnsje @F
 cmp bl,$pExitje @F
 cmp StackDi,Z.CurrentDOjz @Fmov dx,bx;Assert DX free to use. (Visible in CV)
 shr bx,1mov bl,Bptr OpFlags[bx]Qry bl,EndsClausejz @F
 int 3mov ah,$DosExitint 21h
@@:
endif

XCycle:

if 0
 call Consist; Check overwrite of Symbols.
endif

; Here with the soft instruction pointer on the bytes to be interpreted.
if Debug
 cmp si,bpjns @Fint 3@@:
endif
 mov bx,Wptr gs:[CursorSi]
; Even means it is an operand. There are usually more operands than operators.
 test OperandBl,1jnz Operatoradd CursorSi,2
 test OperandBl,$CaseTargetjnz NotLoadVariable

; Alignment 8 means procedure scope. There are roughly as many of these
; as there are constant references (program scope).
; FS is maintained addressing the variables of the current procedure.
; The following Up (=add) puts the previous operand (if any) underneath (lower
; address than) StackDi, and the new operand is then positively addressed
; by StackDi.
; It isn't necessary to test for stack overflow here because there is a limit
; on the number of operands that can happen without a function invocation
; intervening and the function will make a check. (Limit is deduced at compile
; time- NYI but conservative view taken.)
FetchBx:Uptest Vbxf.Dtype,$Testjg NotPresent
; If control branched off, it will return to XCycle when a value to be used
; for the operand is established.
; Whatever the datatype of the value, 8 bytes contains or anchors it.
 Move V,Vbxfjmp XCycle

NotLoadVariable:jpo ProgScope
; $CaseTarget (=6) modulo 8 means a variable being assigned to.
 cmp Vbxt.Dtype,$Exposedje @F
 Move Vbxt,VDownjmp XCycle
@@:push XCyclejmp AssignExposed

; Excursion from XCycle for loading a constant.
ProgScope:UpMove V,Vbxejmp XCycle

; The Rejumps either change CursorSi, or don't, according to the hardware
; flags. They are the "conditional jumps" of Pcode.  Which one to use is
; determined by the Pcode operator, by this time converted into which of
; this array of conditional jumps is to be used.
; Once upon a time Rejumps were four bytes like je @F xax CursorSi @@:ret
; but latest should be faster.

if Solid
Rejumps:
 je @Fmov CursorSi,ax@@:BackRet
 nopnopnop
 jne @Fmov CursorSi,ax@@:BackRet
 nopnopnop
 jb @Fmov CursorSi,ax@@:BackRet
 nopnopnop
 jbe @Fmov CursorSi,ax@@:BackRet
 nopnopnop
 jae @Fmov CursorSi,ax@@:BackRet
 nopnopnop
 ja @Fmov CursorSi,ax@@:BackRet

Boolery:; Turns what is in hardware flags to a Boolean byte in al.
; sete al ret will fit in four bytes but nowadays we use eight - see Rejumps.
 sete Bptr(V.Mantissa)BackRet
 nopnopnop
 setne Bptr(V.Mantissa)BackRet
 nopnopnop
 setb Bptr(V.Mantissa)BackRet
 nopnopnop
 setbe Bptr(V.Mantissa)BackRet
 nopnopnop
 setae Bptr(V.Mantissa)BackRet
 nopnopnop
 seta Bptr(V.Mantissa)BackRet

BooleryRejumps equ Boolery-Rejumps
endif
;------------------------------------------------------------------------------
; When I changed the search from a subroutine to inline the performance
; went down (!) so presumably alignment is important.
;------------------------------------------------------------------------------
comment~ The principal runtime activity is to go from the state where the tail
parts are on the stack to the the state where they are pruned and the tailed
variable is known.   This is sufficient when the subject is being
assigned to, but fetch needs more.  Fetch is three-stage; the subject might have
a value, or the stem might supply one, or the stem might not.  In the last case,
both the stem and the tail are needed again as part of the default value.

Considerable scarcity of segment registers here. We can't save and restore
segment registers because of compaction effects. The segment registers have
to be committed or reloadable. We have committed SS and CS. There is no
choice about ES during most of this routine because of movs and cmps use.
It is just too clumsy to keep reloading DS, so we let FS be the exposed
variable pool rather than just the current one.

~
; Concatenates parameters (with '.' between them) to make a tail value.
; Looks under the stem (which comes in fs:bx) for item with that key, makes it
; if necessary.  AX says how many parameters.
; Results fs:bx for stem (upper of pair), ds:si for tailed item.
; StackDi adjusted. ax & cx & dx not preserved.

DotsFsBxDsSi:
; AX defining how many parts.
; Change fs to required pool, if necessary.
 cmp Vbxf.Dtype,$Exposedjne @Fcall ExposedFs@@:
; Find the segment owned by the stem.
; If stem says dropped, a segment is needed which will hold all the keys.
 cmp Vbxf2.Dtype,$Droppedjne @Fcall StemAllocVbxDs@@:
DotsFsBxDsSiX:; Entry from externals lookup.
 mov Z.StackHi,StackDimov Z.StackLo,StackDisub Z.StackLo,ax
if Debug
 TestReg axjns @Fint 3@@:
endif
; Copy parts of tail to make complete key.
 mov StemEs,Vbxf2.Sg
 mov si,He.Avail; Points to spare space.lea ToFindDx,J.Key
 Up
 mov ax,ToFindDx; ax as cursor across key.
TailLenLoop:Down
@@:push StackDicall ToDsSiCx
; Assure room in stem segment.
 mov di,axadd di,cxinc dicmp di,He.Triggerjb @F
 mov Z.Stem,StemEsmov SegOffDi,Zshape.Stem
 call MoreSpaceEsmov Vbxf2.Sg,StemEspop StackDijmp @B
; Add tail part to the key, with dot after. AX advances.
@@:mov di,ax
; Trade size for speed.
  cmp cx,8
  ja  SlowRep
  mov eax,Dptr[si]
  mov Dptr es:[di],eax
  mov eax,Dptr [si+4]
  mov Dptr es:[di+4],eax
  add di,cx
PostRep:
 mov al,'.'stosbmov ax,di
 pop StackDicmp StackDi,Z.StackLo
if Debug
 jae @Fint 3@@:
endif
 jne TailLenLoop
if 0
; In this variation, a preliminary run works out key length so that test
; for space is only needed once.
; For the record, this was 3% slower for REXXCPS overall.
endif
if 0
; In this variation, a limit is set on key length.
; This didn't noticieable speed things up.
endif
; Now ready to see if stem has already used this key.; ES:ToFindDx at the key.
 sub ax,ToFindDxdec ToFindLenAx; Lose trailing dot.

; EXPOSE at the item level can lead to repeat lookup in a different pool.
; Enter here with ES:DX::AX as the key.
ExposedLoop:mov ds,Vbxf2.Sg
;------------------------------------------------------------------------------
; This section does the search for the keyed item.
;------------------------------------------------------------------------------
; ds&es at segment.
; ToFindLenAx and ToFindDx set.
 push StemBxmov ProbeBx,Hd.Probemov TailSi,ToFindDx
 sub TailSi,Jshape.Keymov Z.NewJshape,TailSilea LowSi,J.Lower
; ds now at segment for keys & Vshapes. bx the probe to start looking.
; Lookup algorithm is like that for symbols, but has keys embedded.
; So limited comments on this one.
 lea HighDi,[LowSi+Jshape.Higher-Jshape.Lower]
 jmp WhileStemBxQ

; Backwater for hungover bit.
SlowRep:rep movsb
  jmp PostRep

; Do the string (with length) compare.
StemLoopQ:cmp ToFindLenAx,Jbx.KeyLenja ProbeBelow2Qjb ProbeAboveQ
 push sipush dimov di,ToFindDxlea TailSi,Jbx.Keymov cx,ToFindLenAx
 repe cmpsbpop dipop sijae ProbeBelowQ
ProbeAboveQ:mov [LowSi],ProbeBx; Complete prior iteration
 lea LowSi,Jbx.Highermov ProbeBx,[LowSi]
; A little bit of duplication for speed.
 TestReg ProbeBxjnz StemLoopQjmp NewStemBx

ProbeBelowQ:je ProbeMatchQ
ProbeBelow2Q:mov [HighDi],ProbeBxlea HighDi,Jbx.Lowermov ProbeBx,[HighDi]
WhileStemBxQ:TestReg ProbeBxjnz StemLoopQ; Drop through if not found.
NewStemBx:z Wptr[LowSi]z Wptr[HighDi]
; Commit the new item we have been making.
; Key has already been copied into the relevant place.
 pop StemBxmov TailSi,Z.NewJshape
 mov J.KeyLen,ToFindLenAx
 lea di,J.Keyadd ToFindLenAx,dimov Hd.Avail,ax
 mov Hd.Probe,TailSi
 stcjmp FoundKey

ProbeMatchQ:;Subject found at ProbeBx.
 mov ax,Jbx.Lowermov [LowSi],axmov ax,Jbx.Highermov [HighDi],ax
; Address the place found with si and recover bx of the stem.
 mov TailSi,ProbeBxpop StemBxmov di,Z.NewJshape
 mov edi,Jdi.Pairmov J.Pair,edi
 mov Hd.Probe,TailSi; Probe for next time look at this stemmed.
 clc
FoundKey:
;------------------------------------------------------------------------------
; DS:SI now the relevant Vshape item.
;------------------------------------------------------------------------------
; Leave StackDi ready to take a value.
 mov StackDi,Z.StackLo
 jc TailNew
; If this element is EXPOSEd, we need to lookup again, in the caller's pool.
 cmp Vsid.Dtype,$Exposedje DotsExposed; And then ExposedLoop
 mov ProgEs,Z.ProgScope
 ret

; We need to find the A.B which isn't EXPOSEd.
DotsExposed:call ExposedFs
; Search will be with the same key.  Hard work to copy it to the new subject.
 mv es,ds; Segment currently having key.
; Stem may never have been used in the caller's pool.
 cmp Vbxf2.Dtype,$Droppedjne @Fcall StemAllocVbxDs@@:
 mv ds,es
 push di
 mov es,Vbxf2.Sg;
 mov di,He.Avail
 mov ax,J.KeyLenmov es:Jdi.KeyLen,axmov cx,ax
 lea TailSi,J.Keylea di,Jdi.Keymov dx,diRepmovsb
 pop di
; Look again for this key on this stem in this pool.
 jmp ExposedLoop

TailNew:mov Vsid.Dtype,$Omitted; Mark as new item.
 mov ProgEs,Z.ProgScope
 ret

StemAllocVbxDs:; First time some tail of a stem is used. Second of pair gets
; to address the segment for tails and their values.
 pushamov bx,512-8;Triggerlea cx,[bx+8]; SegSize bytes.
 mov SegOffDi,Zshape.Stemcall InitSegDs
 popamov Vbxf2.Sg,ds
; Compaction failure when this was before the allocate!
 mov Vbxf2.Dtype,$Stem; It is not a variable, but not now $Dropped either.
 ret
;------------------------------------------------------------------------------
; The operand was not one that could be loaded directly from the ProgScope
; or VarScope arrays.  The effect of the code here is as if it was.
;------------------------------------------------------------------------------
; There are various reasons why we might not yet have the final value.
NotPresent:push XCycle
NotPresentX:; Entry point when called from eg Parse.
 mv ds,fs; Exposed only happens for variables.
;; Might be better code if we altered fs? Would have to reload after.
 cmp Vbx.Dtype,$Exposedjne NotExposed
; Assert - loop for non-exposed bound to find one.
@@:mov ds,Hd.UpPoolcmp Vbx.Dtype,$Exposedje @B
NotExposed:test Vbx.Dtype,$Testjg @F
 Move V,VbxBackRet

; Here if now-non-exposed is not present. (Dropped or SIGL type)
@@:cmp Vbx.Dtype,$Droppedjne NotDropped
; Is NOVALUE enabled?
 call HeritageDicmp L.NoValue,0pop StackDijne @F
 On Z.Cancel,WasDropped; For trace >L>
 call ValueIsNameBackRet

; NYI some lookahead here since tails of compounds don't give NOVALUE.
; Lookahead for stemmed variable cases.
; Raise NOVALUE.
@@:Error49Bp

NotDropped: Move V,Vbx

comment~ Most things under program scope, segment Z.ProgScope, are constants.
References to program scope variables, eg .MN, are followed by SysVar$$ so
that in the usual case Z.ProgScope can load constant without needing
a test.
~
SysVar$$:test V.Dtype,$Testjg @FBackRet

@@:; Assert - cannot be exposed.
 push CursorSi
; Here for ones where conversion to number has been postponed.
 cmp V.Dtype,$MsgNumjne NotMsgNum
; This type, until needed, is stored with MajMin as binary.
 push StackDimv es,ssmov dx,V.MantLow
; Major number as part of short string result, via Zone
 movzx ax,dhcall Ax2DsSiCxrep movsb
; Dot and minor number unless zero.
 mov al,dlTestReg axjz @F
 mov Bptr es:[di],'.'inc dicall Ax2DsSiCxrep movsb
; Set Dtype of result.
@@:mov ax,dipop StackDisub ax,StackDiadd al,$NullStringmov V.Dtype,al
 jmp RetEsSi

NotMsgNum:cmp V.Dtype,$Sigljne NotSigl
; Use compile phase to find line number.
 move Z.Synch,V.MantLow
 mov Z.Cursor,$StrideH
 z Z.Scanp
 push StackDicall Compilingpop StackDi
 mov ProgEs,Z.ProgScope
 mov fs,Z.VarScope
 mov gs,Z.Code
; ??? NYI does Z.Stack survive? or matter?
 mov V.ExpAnd,ebp
 mov V.Mantissa,ebp
 move V.MantLow,Z.ClauseLine; Or is it meant to be Z.Lines?
 jmp RetEsSi

NotSigl:Error49Bp

; End of loading operands.

;------------------------------------------------------------------------------
; Abut and Cat have special concerns over compaction since three strings
; need pinning at the same time.
;------------------------------------------------------------------------------
TotalCx is <cx>
MovsCx is <cx>
RHSLenDx is <dx>
LHSLenBx is <bx>
Abut$$:push CursorSi
; If the left one isn't a string then better convert it now so that no
; compaction threat from ToDsSiCx of it.
 test V0.Dtype,$Testjnz @F
 Downcall ToDsSiCxUp
; Remember RHS
@@:call ToDsSiCxmov RHSLenDx,cxpush dspush si
; Look at LHS
 Downcall ToDsSiCxmov LHSLenBx,cx
; If room, just append in place.
 add TotalCx,RHSLenDxjc Raise5p1dcmp TotalCx,7ja AbutAlloc
; Allow for possibility of a short AwayString.
 cmp V.Dtype,$AwayStringje AbutAlloc
; Setup ES:DI for place LHS to go.
 mv es,dsand V.Dtype,-8add V.Dtype,cl; Adjust length of LHS.
 xchg LHSLenBx,diadd di,si; Position inside LHS for RHS to go.
 jmp CatAppend

AbutAlloc:mov Z.CatTotal,TotalCx
; Only Abut and Cat care about possible appended allocation so the code for
; that is put inline, both places.
; This sort of allocate may turn out to be an extend of the current $AwayString
; stack item. Maybe not faster than allocate but may save a long move.
; Test is whether the LHS operand is actually just ahead of what we are
; about to allocate.
 cmp V.Dtype,$AwayStringjne AbutOther
 AllocAppend AbutOtherPop; Jump if cannot append.
 pop si
; Stack item has been changed to make room for RHS.  Setup target of RHS copy.
 xchg LHSLenBx,StackDiadd di,axjmp CatAppend
; New space in memory is needed.
AbutOtherPop:pop si
AbutOther:call AllocateCx_EsAx
; RHS may have moved when compaction, invalidating pushed registers.
 jnc @FPopJunk siPopJunk si
 Upcall ToDsSiCxDownpush dspush sicall ToDsSiCx@@:
; Maybe LHS is short string - must move before altering stack item.
 mov MovsCx,LHSLenBxmov bx,StackDimov di,axRepmovsbjmp CatLong

; See also Abut$$
Cat$$:push CursorSi
; If the left one isn't a string then better convert it now so that no
; compaction threat from ToDsSiCx of it.
 test V0.Dtype,$Testjnz @F
 Downcall ToDsSiCxUp
@@:call ToDsSiCxmov RHSLenDx,cxpush dspush si
 Downcall ToDsSiCxmov LHSLenBx,cx
; Allow for separating character.
 add TotalCx,RHSLenDxjc Raise5p1d
 inc TotalCxjz Raise5p1dcmp TotalCx,7ja CatAlloc
; Allow for possibility of a short AwayString.
 cmp V.Dtype,$AwayStringje AbutAlloc
; If room, just append in place.
 mv es,dsand V.Dtype,-8add V.Dtype,cl; Adjust length of LHS.
 xchg LHSLenBx,diadd di,si; Position inside LHS for RHS to go.
 mov al,' 'stosb
CatAppend:pop sipop dsmov MovsCx,RHSLenDxRepmovsb; Copy the RHS
 mov StackDi,bx
 jmp RetEsSi
CatAlloc:mov Z.CatTotal,TotalCx
 cmp V.Dtype,$AwayStringjne CatOther
 AllocAppend CatOtherPoppop si
; Stack item has been changed to make room for RHS.
 xchg LHSLenBx,StackDiadd di,axjmp CatMid

CatOtherPop:pop si
CatOther:call AllocateCx_EsAx
; RHS may have moved when compaction, invalidating pushed registers.
 jnc @FPopJunk siPopJunk si
 Upcall ToDsSiCxDownpush dspush sicall ToDsSiCx@@:
; Maybe LHS is short string - must move before altering stack item.
 mov MovsCx,LHSLenBxmov bx,StackDimov di,axRepmovsb
CatMid:mov cx,axmov al,' 'stosbmov ax,cx
CatLong:pop sipop dsmov MovsCx,RHSLenDxRepmovsb; Copy the RHS
; Fill fields of stack item to address result
 mov StackDi,bxmov TotalCx,Z.CatTotal
 mov V.Len,TotalCxmov V.Sg,es
 mov V.Pt,axmov V.Dtype,$AwayString
 jmp RetEsSi

Nop$$:mov Ve.Dtype[$?CLAUSETIME],$NullString
 BackRet

;------------------------------------------------------------------------------
; PARSE stage one is to get the subject addressed by the current stack variable.
;------------------------------------------------------------------------------
comment~ There are a variety of PARSE sources, for which we use several
pcode points and a marker for uppering. The FindNextBreak, $8.3.17, is done
at parser time (to the extent of what sort of search - Pattern or +-=
forms of positional). These markers will find their parameter is on the stack.
All the relevant targets follow, so that WordParse can be done on the isolated
source. The set of targets is ended by another trigger, a marker to end the
parse, or the marker for a comma in a template.

The schema described in the paragraph above assumes that all the values and
targets in the template-list are simple two byte references.  The execution
time parse scan could not cope with more so it is paused, and the general
pcode mechanism used, for complex cases.  These cases must allow for the
possibility of a compaction occurring.

Parse is important for execution speed. The Intel architecture isn't that
good for scanning but we can work on other aspects. We should avoid going back
to the interpreter loop too often. So the assignments are done without
having a $pAssign opcode for them, and without taking the source value
up to the stack and back.

Parse terminology: "Subject" is the thing parse scans; in the case of PARSE ARG
there can be several. A "section" is a substring of that isolated by a "trigger"
which is a pattern or column. The contents of a runtime section correspond
to a set of target variables (isolated by the trigger spec) in the compile
time parse clause. A "Break" is the pattern that separates sections. It is
null for a column trigger. Parsee is a collection of info about the parsing.

~
CursorDi is <di>
SectionSi is <si>
SectionDi is <di>
SectionDx is <dx>
DataLenCx is <cx>
SectionCx is <cx>
PatternSi is <si>

Parse$$:lodsb Bptr gs:[CursorSi]mov bl,al
 cmp Bptr gs:[CursorSi],$mUpperjne @Finc CursorSiOn Z.Cancel,ParseUpper@@:
 push CursorSijmp SourceTable[bx]

if Solid
SourceTable:
 dw Var$
 dw With$
 dw Arg$
 dw LineIn$
 dw Pull$
 dw Source$
 dw Version$
endif

; This can be repeated at the template comma.
Arg$:z Z.ParseeNumUp
ArgInc:inc Z.ParseeNum; All the other sources keep ParseeNum at zero.
; Set StackSi for relevant argument.
 mov ax,Z.ParseeNumshl ax,$ShiftV
 mov LevelSi,Z.Levelmov StackSi,Lsi.Arg0add StackSi,ax
; Put copy of it at current stack item.
 Move V,Vsicall ToDsSiCxjmp FromArg

TemplateComma$:push CursorSicmp Z.ParseeNum,ZeroBpjne ArgIncpop CursorSi
; Non-ARG so parse a null string.
 move Z.Parsee.Limit,Z.Parsee.Ptjmp LoadTrigger

LineIn$:
 Error49Bp

Pull$:; Push/Pull is at the high end of Z.Serial.
; Length of aggregate is first word of Z.Serial.
; Items have their length at both ends of the item.
 mov al,$SerialQuecall Serializemv ds,ss
; Another source if nothing on Rexx stack.
 mov si,Wptr Z.SerialTestReg sijz PullSysin
; Do the "pop".
 mov cx,Wptr Z.Serial[si]sub si,cxmov Wptr Z.Serial,si
; Item (including lengths) goes from Z.Serial[si+2] for cx bytes.
; Have to physically copy because where it is can get reused.
Pulled:lea si,Z.Serial[si+4]
 sub cx,4Upcall ResultSpacepush StackDimov di,axrep movsbpop StackDi
 mov ProgEs,Z.ProgScopejmp Var$

PullSysin:; Fill by read of Stdin
; Pretend there are lengths, to share code.
 z bx; Handle of Stdin
 mov dx,offset Zshape.Serial+4mov cx,sizeof Zshape.Serial-4
 mov ah,$DosReadint 21hadd ax,4mov cx,axjmp Pulled

Version$:; Alias the constant from code segment to a stack variable.
 Upmv ds,csmov si,offset Versionmov cx,sizeof Version
 jmp FromVersion

; This routine makes the V stack variable reflect DS:SI::CX
VasDsSiCx:mov V.Pt,simov V.Sg,dsmov V.Len,cxjmp Away

Source$:Uppush StackDi
; #Configuration #HowInvoked #Source, to be set up as string variable.
; Add up lengths in cx and allocate space.
 mov cx,sizeof Configurationadd cx,Z.HowInvoked
 lds bx,Z.InsSourcemov bx,Jbx.KeyLenadd cx,bx
 push cxmv ds,cscall AllocateCx_EsAx
; Copy Configuration from code segment.
 mov di,axmov cx,sizeof Configurationmov si,offset Configurationrep movsb
; Copy HowInvoked from code segment.
 mov cx,Z.HowInvoked
 cmp cx,sizeof FUNCTIONjne @Fadd si,FUNCTION-COMMAND@@:
 cmp cx,sizeof SUBROUTINEjne @Fadd si,SUBROUTINE-COMMAND@@:
 rep movsb
; And the bit for #Source.
 mov cx,bxlds bx,Z.InsSourcelea si,Jbx.Keyrep movsb
 mv ds,esmov si,axpop cxpop StackDi
 mov ProgEs,Z.ProgScope
FromVersion:; Set stack to reflect the value.
 call VasDsSiCx

Var$:With$:; Stack has the thing to be parsed.
 z Z.ParseeNum; And stays that for these sources.
FromArg:
; We keep a stored copy of the subject during PARSE, on stack so that
; Compaction is aware. (Compaction only during escape)
 Qry Z.Cancel,ParseUpperjz @Fcall CONFIG_UPPER$$@@:call ToDsSiCx
; Z.Parsee.Sg we keep stored because of paucity of segment registers.
; Z.Parsee.Pt we keep stored ready to create an empty segment. (TemplateComma)
; Also keep track of the end of the sections.
 mov Z.Parsee.Sg,dsmov Z.Parsee.Pt,siadd cx,simov Z.Parsee.Limit,cx
; The position of a pattern determines the start of the following section.
 mov Z.BreakStart,simov Z.BreakEnd,si
 pop CursorSi
;------------------------------------------------------------------------------
; Second stage, get the trigger value, eg the pattern for a pattern search.
;------------------------------------------------------------------------------
; If the trigger is not a difficult value to load, we do not need to go
; back to the interpreter loop to load it.
LoadTrigger:mov ax,Wptr gs:[CursorSi]inc CursorSi
NextSection:
; AX is two bytes from the Pcode, with CursorSi moved over one of them.
 cmp al,$mPosRestje PosRest$; No value to load for PosRest$
 cmp Z.ResumeP,ZeroBpjne ParseBcode; Will return to TriggerWith.
if Debug
; Shouldn't be an opcode.test al,1jz @FError49Bp@@:
endif
; It will be a marker or an operand for a trigger.
TriggerArg:test al,02hjnz PSwitch
; It is a (non-complex) operand.
; Load value of variable needed for trigger.
; Advance cursor over the operand and wind up at TriggerWith.
 inc CursorSimov ArrayBx,axUptest al,04hjnz ConTrigger
; Compile time could detect most complications, but not EXPOSED.
 test Vbxf.Dtype,$Testjg @F
 Move V,Vbxfjmp TriggerWith
@@:push TriggerWithjmp NotPresentX
; Load value of constant needed for trigger.
ConTrigger: mov ProgEs,Z.ProgScopeMove V,Vbxe

; Switch on which trigger.  StackDi has the trigger value, if trigger uses one.
TriggerWith:lodsb gs:[CursorSi]; Known to be a marker.

PSwitch:shr al,2movzx bx,aljmp Triggers[bx-$mParseEscape/4]
if Solid
Triggers:
 dw ParseEscape$ ; Complex operand. Get and resume at TriggerWith.
 dw ParseEnd$
 dw PosRest$     ; Won't happen here - was tested early.
 dw Pattern$
 dw PosEq$
 dw PosPlus$
 dw PosMinus$
 dw TemplateComma$
endif

;------------------------------------------------------------------------------
; Third stage.
; Here we deal with a section of the parse. We deduce where the section runs,
; and record BreakStart and BreakEnd for use next time around in determining
; the next section.  Goes on to WordParse, via Section.
;------------------------------------------------------------------------------
Pattern$:push CursorSicall ToDsSiCx
 Downpop axpush StackDipush ax; CursorSi nearest as WordParse needs.
; Search for this pattern.
 JcxzQ NullPattern; Null matches the end of the subject.
; Setup where to search.
 mov Z.PattLenEtc,cxmov es,Z.Parsee.Sgmov SectionDi,Z.BreakEnd
 mov SectionCx,Z.Parsee.Limitsub SectionCx,SectionDi
; PatternSi is at pattern, SectionDi at subject, SectionCx to look over.
; Stop on places that match the first character.
 mov al,[PatternSi]
SingleNext:repne scasbjne NullPattern
; One character match. Is the pattern longer?
 mov dx,Z.PattLenEtcdec dxjz HasPattern
; Compare rest of pattern, without advancing. dx is amount left to compare.
 cmp dx,SectionCxja NullPattern
 push SectionDipush SectionCxpush PatternSi
 inc PatternSimov cx,dxrepe cmpsbpop PatternSipop SectionCx
 je HasPatternPoppop SectionDijmp SingleNext
HasPatternPop:PopJunk ax
; Match over all pattern.
HasPattern:; SectionDi is now position after the last matching character.
 mov SectionSi,Z.BreakEnd; Start of this section.
 mov Z.BreakEnd,SectionDisub SectionDi,Z.PattLenEtc
 mov Z.BreakStart,SectionDijmp Section

NullPattern:mov SectionSi,Z.BreakEnd
 mov ax,Z.Parsee.Limitmov Z.BreakEnd,axmov Z.BreakStart,axjmp Section
; Here the column for the limit of a new section is specified.
PosEq$:call ToWholeEbxjc Raise26p4Downpush StackDipush CursorSi
 mov SectionSi,Z.BreakEnd
; Convert from column to segment offset.
comment~ If we kept bx as Z.Parsee.Pt we would avoid conversion, and escapes
would be simpler.  But then addressing would be [bx+si] and so scansb could
not be used.
~
 mov ax,Z.Parsee.Ptadd ax,bxdec axmovzx edx,axjmp PosNew

; Relative means relative to start of last section delimiter.
; If we do this in 16 bits, negatives will look like large addresses.
PosMinus$:call ToWholeEbxjc Raise26p4neg ebxjmp @F
PosPlus$:call ToWholeEbxjc Raise26p4
@@:Downpush StackDipush CursorSimovzx edx,Z.BreakStart
 mov SectionSi,dxadd edx,ebxmov ax,dx
; Keep position to start next section within range.
PosNew:movzx ecx,Z.Parsee.Ptcmp edx,ecxjge @Fmov ax,Z.Parsee.Pt@@:
 movzx ecx,Z.Parsee.Limitcmp edx,ecxjl @Fmov ax,Z.Parsee.Limit@@:
 mov Z.BreakStart,axmov Z.BreakEnd,ax
Section:; Section goes from current SectionSi to new Z.BreakStart or end of
; subject. Hence DataLenCx.
 mov cx,Z.BreakStartcmp SectionSi,Z.BreakEndjb @Fmov cx,Z.Parsee.Limit@@:
 jmp SectionGo

PosRest$:; Section runs to end of parsee.
; No need to set things for next section, or to range check.
 push StackDipush CursorSimov SectionSi,Z.BreakEndmov cx,Z.Parsee.Limit
SectionGo:sub DataLenCx,SectionSi

;------------------------------------------------------------------------------
; Stage 4 - Bits of the identified section are assigned to variables.
; WordParse - see the Standard.
;------------------------------------------------------------------------------
comment~ Here we are at a point in the pcode where a trigger has been processed,
setting SectionSi to a section of the subject, length DataLenCx.
Z.BreakStart and Z.BreakEnd are also set.
There follows in the pcode a set of targets to be fulfilled from the section.
StackDi and CursorSi are already pushed.  CursorDi fills usual CursorSi role in
this code, so that scansb can be used on the subject.

~
 pop CursorDimov ds,Z.Parsee.Sg
; This is a routine where Pcode and Bcode are distinquished during execution.
 cmp Z.ResumeP,ZeroBpjne ParseB
; Looking though ds:si:cx for words. Assigning to targets given in Pcode.
; The loop will advance si with corresponding reduction in cx, in conjunction
; with di advancing through targets.
NextTarget:mov OperandBx,gs:[CursorDi]
; It will either be a target, or a marker (for EndParse or ParseEscape),
; or an operand which is next trigger value.
 test bl,$CaseTargetjpo WpDone
; It is a target. Cursor advances over target.
 inc CursorDiinc CursorDisub OperandBx,$CaseTarget
; Make fs:bx the item to be assigned to.
 cmp Vbxf.Dtype,$Exposedjne @Fcall ExposedFs@@:
 push fspush OperandBx
; Enter here from escape for tailed cases.
ParseAssign:; The next part of the subject is to be assigned to (pushed) FS:BX.
; There will be no compaction while determining what to assign.
 JcxzQ AssignNull; Assign null is same whether this is last of section or not.
 mov al,Bptr gs:[CursorDi]
 test al,$CaseTargetjz WpLastjpe WpWordcmp al,$mParseEscapejne WpLast
; When not last of section, target gets just one word.
WpWord:
 mov bx,Attributes; Prepare to test AllBlanks.
; Move SI on to nonblank.
@@:lodsbXlatBDLSjnz @FLoopQ @Bjmp AssignNull
; Came out of the above loop with si advanced but cx not fully decreased.
; SectionDx to remember start of the word.
@@:mov SectionDx,SectionSidec SectionDxdec cxjz WpOne
; Move SI on to blank.
@@:lodsbXlatBDLSjz @FLoopQ @B
; Nothing ends the word. We want to do further work with DataLenCx=0
WpOne:inc DataLenCxinc SectionSi
@@:dec DataLenCx; Word terminator not part of residue.
; SectionSi is beyond the blank but that is OK - don't want to scan it again.
 mov Z.PattLenEtc,DataLenCx; Save use as residue, start use as word length.
 mov cx,SectionSisub cx,SectionDxdec cx; Word length.
 xchg SectionSi,SectionDx; Back to start of the word. SectionDx for next scan.
; Assign that word away, to variable specified in pcode, now ArrayBx.
; ds:si::cx is the word.
WpLast:; Enter here for last target -last one gets the residue, blanks and all.
 pop OperandBxpop fs
; I hate to have a test that costs even when trace isn't used but this place
; is so deep in parse that I see no reasonable way to use $pTraceEvent instead.
 Qry Z.Cancel,ParseTrace
 jz NotTracingpushamov al,$TraceAssign
 cmp OperandBx,$?Discardjne @Fmov al,$TraceDot@@:
 call TraceEventXpopa
NotTracing:
; Moot whether testing for 'no target' is worth the saving.
; It didn't help REXXCPS much. So we assign to $?Discard instead.
 cmp cx,7ja @8p3p17A
 Move Vbxf,Vsid,eaxadd cl,$NullStringmov Vbxf.Dtype,cl
; Rescan from where we had reached.
WpResume:mov fs,Z.VarScope
 mov SectionSi,SectionDxmov DataLenCx,Z.PattLenEtcjmp NextTarget

@8p3p17A:; Alias setup
 mov Vbxf.Sg,dsmov Vbxf.Pt,simov Vbxf.Len,cxmov Vbxf.Dtype,$AwayString
 jmp WpResume

AssignNull:
 Qry Z.Cancel,ParseTracejz NotTracingXpushamov al,$TraceAssign
 cmp OperandBx,$?Discardjne @Fmov al,$TraceDot@@:
 call TraceEventXpopa
NotTracingX:pop OperandBxpop fsmov Vbxf.Dtype,$NullStringjmp NextTarget

; Parsee to be taken off stack at end of PARSE clause.
ParseEnd$:DownOff Z.Cancel,ParseUppermov ProgEs,Z.ProgScopeBackRet

WpDone:mov Z.PattLenEtc,SectionSi
 mov CursorSi,CursorDipop StackDimov fs,Z.VarScope
; The sequence of targets was ended either by a marker or by the operand
; part of the next trigger. In the latter case we go to work
; on the next section of the parse. In the former case we may have an
; operandless trigger like PosRest or ParseEnd, or this may not really
; be the end of the targets, just a target that needs AssignDotsP$$.
; That target calculation will start with a $mParseEscape.
 mov ax,bxinc CursorSicmp al,$mParseEscapejne NextSection
;------------------------------------------------------------------------------
; Escapes from simple parsing.
;------------------------------------------------------------------------------
; We won't come here often but there is a lot to do.
; If Compaction happens the parse subject will move in memory. So our
; pointers into it have to be made relative to its first byte and
; reconstructed later.

ParseEscape$:
; The simple parse for a trigger will have an operand then a code for the
; type of trigger. If the operand cannot be represented as just a two-byte
; reference (eg because tailed) then escape is made to load the operand.
; The other use of $mParseEscape is similar, when a target is tailed.
; Make info relative to start of subject.
 mov ax,Z.Parsee.Pt
 sub Z.Parsee.Limit,ax
 sub Z.BreakStart,ax
 sub Z.BreakEnd,ax
 sub Z.PattLenEtc,ax
 mov ProgEs,Z.ProgScope
 BackRet; PARSE suspends for a while.
; Here from XCycle when complex trigger operand has been loaded.
ResumeParse$$:inc CursorSipush TriggerWith
SubjectRestore:push CursorSi
; Make info reflect (possibly) new position of parsee.
 call ToDsSiCx
 mov Z.Parsee.Sg,ds
 mov Z.Parsee.Pt,si
 add Z.Parsee.Limit,si
 add Z.BreakStart,si
 add Z.BreakEnd,si
 add Z.PattLenEtc,si
 pop CursorSiret
; Here from XCycle when tail parts have been loaded.
AssignDotsP$$:; This is like AssignDots$$ to start with.
 lodsw gs:[CursorSi]mov StemBx,axpush CursorSi
 mov ax,StackDisub ax,Z.CurrentDOsub ax,2*$StrideV
 call DotsFsBxDsSiDownmov fs,Z.VarScope
; We have worked out what to assign to, Vsid, but the value to assign
; is not what is on the stack. The parse subject is on the stack and
; only a part of that is to be assigned.
; Use the code that decides what part.
; We left the parse in the WordParse stage, which operates with StackDi pushed
; and CursorDi replacing CursorSi role.
 pop ax; Was CursorSi
 push StackDi
 push dspush si; Will restore to fs:bx
 call SubjectRestoremov CursorDi,axmov SectionSi,Z.PattLenEtc
 mov DataLenCx,Z.Parsee.Limitsub DataLenCx,SectionSijmp ParseAssign

;------------------------------------------------------------------------------
; Spacewise, I don't like duplicating the WordParse code. The alternative
; of first copying the isolated word to $pDiscard and then using Bassign
; worked but makes Bcode dependent on VarScope which isn't logical.
;------------------------------------------------------------------------------
; We might needed to enhance this section to allow more complex PARSE in Bcode.
; Loading trigger argument from Bcode:
ParseBcode:cmp al,String1jne @Fcall String1$$jmp TriggerWith@@:
 cmp al,Onejne @Fcall One$$jmp TriggerWith@@:Error49Bp

ParseB:
; Looking though ds:si:cx for words. Assigning to targets given in Bcode.
; The loop will advance si with corresponding reduction in cx, in conjunction
; with di advancing through targets.
NextTargetB:mov ax,gs:[CursorDi]
; al is ultimate target. Will be checked for ParseDot.
 test al,1jnz WpDoneB; Operator to load constant for next section, end section.
; Both subcodes and operands are even, so the test for operands is by value.
 cmp al,$mPosRestjna WpDoneB
 inc CursorDi; Over target.
 JcxzQ AssignNullB
 mov bl,altest ah,1jnz WpLastBcmp ah,$mPosRestjna WpLastB
WpWordB:push ax
 mov bx,Attributes; Prepare to test AllBlanks.
; Move SI on to nonblank.
@@:lodsbXlatBDLSjnz @FLoopQ @Bpop axjmp AssignNullB
; Came out of the above loop with si advanced but cx not fully decreased.
; SectionDx remembers start of the word.
@@:mov SectionDx,SectionSidec SectionDxdec cxjz WpOneB
; Move SI on to blank.
@@:lodsbXlatBDLSjz @FLoopQ @B
; Nothing ends the word. We want to do further searches with DataLenCx=0
WpOneB:inc DataLenCxinc SectionSi
@@:dec DataLenCx; Word terminator not part of residue.
; SectionSi is beyond the blank but that is OK - don't want to scan it again.
 mov Z.PattLenEtc,DataLenCx; Change use.
 mov cx,SectionSisub cx,SectionDxdec cx; Word length.
 xchg SectionSi,SectionDx; Back to start of the word. SectionDx for next scan.
 pop OperandBx; Was ax.
; Assign that word away, to variable specified in Bcode, now bl.
; ds:si::cx is the string.
WpLastB:cmp bl,ParseDotje WpResumeB
; Put it on the stack, so as to use Bassign to put it away.
 pop ax; StackDipush axpush CursorDimov StackDi,ax
 Upcall VasDsSiCxmov bh,0FFhcall Bassignpop CursorDi
; Rescan from where we had reached in getting that word.
WpResumeB:mov SectionSi,SectionDxmov DataLenCx,Z.PattLenEtcjmp NextTargetB

; (CX is zero but is there a risk about DsSi?)
AssignNullB:mov bl,almov Z.PattLenEtc,ZeroBpjmp WpLastB

WpDoneB:mov CursorSi,CursorDipop StackDi
; The sequence of targets was ended either by a marker or by the next constant
; trigger.
 inc CursorSitest al,1jnz TriggerArg
 cmp al,$mPosRestjna PSwitchjmp TriggerArg
;------------------------------------------------------------------------------
; This lot are about looping.
;------------------------------------------------------------------------------
Number$$:push CursorSi; The expression of DO N=Expr...
; According to $6.3.6, check on numberness should be before check of TO/BY/FOR.
 call NumDxBxjc Raise41p6
; Build DO block over where the parameter was.
 add StackDi,$StrideD-$StrideVcmp Z.ResumeP,ZeroBpjne @F
 mov Z.Stack,StackDimov Z.CurrentDO,StackDi
@@:call StackSafemov D.Rec,0
; Default BY
 mov D.By.ExpAnd,ebpmov D.By.Mantissa,ebpinc D.By.Mantissa
 RetSi

ControlVar$$:
; The thing to be assigned was noted (maybe long ago).
; First argument of this Pcode is a target, as on Assign$$.
 sub StackDi,$StrideD-$StrideV; Tos now value to be assigned.
 cmp Z.ResumeP,ZeroBpje @F
 movsx bx,gs:Bptr[CursorSi]inc CursorSi
; This says where the control variable is relative to stack-with-this-DO
 push bxadd bl,(2*$StrideD/$StrideV)call Bassignpop bx
 jmp Bassigned
@@:
 call Assign$$
Bassigned:; What stored now in ecx:eax
 add StackDi,$StrideD; Back to addressing the loop block.
 Move V2; Have to place the CV value again so as to share compare with TO.
 mov D.CV,bx; Set CV field in LoopBlock.
; Set Leaving field in LoopBlock from argument.
 lodsw gs:[CursorSi]mov D.Leaving,ax
AsControlVar:
 mov D.Iteration,CursorSi; Set Iterate field in LoopBlock to here.
; The test against TO is like the one at the end of a loop except that if
; it doesn't LEAVE it needs CursorSi where it is now rather than at UNTIL
; stuff.
 push StackDicall CompareTOpop dx
 cmp dx,StackDije @Fret; CompareTO did LEAVE
; If here is a jump, this is Until and the Iterate avoids the jump.
@@:cmp Z.ResumeP,ZeroBpjne ACV
 cmp Bptr gs:[CursorSi],$pJumpjne @Fadd D.Iteration,3@@:ret

ACV:cmp Bptr gs:[CursorSi],_Jumpjne @Fadd D.Iteration,2@@:ret

DotControlVar$$:
; This is the more complicated variation, so that ControlVar$$ can be kept fast.
; The code layout is like:  (expr) $pNumber, (expr) $pTo, Tail1 Tail2,
; $pDotControlVar & args, $mRepTail & arg,body of DO, $pIterCV
; Argument one of $pDotControlVar is a target, as on Assign$$.
; Argument of $mRepTail is a label, the place to go to reload tail
; components. (At Tail1 in example)
; On iteration the loop picks up at loading the tails. Whether this is first
; time or not, we need the address of the control variable.
; The $mRepTail part is not there if CV is A. rather than A.B
 lodsw gs:[CursorSi]
 cmp Bptr gs:[CursorSi+2],$mRepTailje @F
; Here for A.
 Error49Bp
@@:mov StemBx,axpush CursorSi
 mov ax,StackDisub ax,Z.CurrentDOsub ax,$StrideV; At least a tail
 call DotsFsBxDsSi
; DotsFsBxDsSi allowed for value pickup by Dots$$.
 btr Z.Cancel,FromIterCVjc BackToIterCV
 sub StackDi,$StrideD; Tos now value to be assigned.
 Move Vsid,VDownmov fs,Z.VarScope
; What stored now in ecx:eax
 add StackDi,$StrideD; Back to addressing the loop block.
 Move V2; Have to place the CV value again so as to share compare with TO.
 mov D.CV,bx; Set CV field in LoopBlock.
; Set Leaving field in LoopBlock from argument.
 lodsw gs:[CursorSi]mov D.Leaving,ax
 mov D.CVinit.Dtype,$NullString; frees space where TailsAt overlaid.
 On D.Rec,HasDot
 pop CursorSiinc CursorSi
 push axlodsw gs:[CursorSi]mov D.TailsAt,axpop ax
 On D.Rec,HasDots; Overrides HasDot.
 jmp AsControlVar

For$$:; Set field in control block
 call ToWholeEbxjc Raise26p3
 Downmov D.ForCount.Mantissa,ebxOn D.Rec,HasForBackRet

To$$:; Set field in control block
 call NumDxBxjc Raise41p4
 Downmov D.To.ExpAnd,edxmov D.To.Mantissa,ebxOn D.Rec,HasToBackRet

By$$:; Set field in control block
 call NumDxBxjc Raise41p5jnz ByChar
 Downmov D.By.ExpAnd,edxmov D.By.Mantissa,ebx
 test dl,1jz @F
ByRetNeg:On D.Rec,ByDown
@@:BackRet

; BY value is numeric but not held as binary.
ByChar:
 call ToDsSiCxDownMove D.By,Vcmp Bptr[si],'-'je ByRetNegBackRet

RepEver$$:Upmov V.Dtype,$Omittedjmp FromEver; bx non-zero

Rep$$:; Set fields in control block.
; The parameter will need to be an integer.
 call ToWholeEbxjc Raise26p2cmp ebx,ebpjs Raise26p2
; Build DO block over where the parameter was.
FromEver:add StackDi,$StrideD-$StrideV
; Assert ToWholeEbx will have filled V.Mantissa and that overlays D.Reps.Mantissa
 cmp Z.ResumeP,ZeroBpjne @F
 mov Z.Stack,StackDimov Z.CurrentDO,StackDi
@@:call StackSafe
; Iterate will come back to the bytes after the $pRep instruction.
; Leave address is the argument of $pRep
 lodsw gs:[CursorSi]mov D.Leaving,axmov D.Iteration,CursorSi
; If here is a jump, this is Until and the Iterate avoids the jump.
 cmp Z.ResumeP,ZeroBpje @F
 cmp Bptr gs:[CursorSi],_Jumpjne IfZero
 add D.Iteration,2jmp IfZero
@@: cmp Bptr gs:[CursorSi],$pJumpjne IfZero
 add D.Iteration,3
; Leave DO if zero repetitions.
IfZero:cmp ebx,ebpje Leave$$BackRet

Until$$:; If T='1' then leave.
 call ToWholeEbxjc Raise34p4
 dec ebxjz DownLeaveinc ebxjnz Raise34p4
WhUntRet:DownBackRet

While$$:; If T='0' then leave.
 call ToWholeEbxjc Raise34p3
 dec ebxjz WhUntRetinc ebxjnz Raise34p3
DownLeave:Down
Leave$$:; Jump to where block says, with UnDo.
 mov CursorSi,D.Leaving
UnDo$$:sub StackDi,$StrideD
 cmp Z.ResumeP,ZeroBpjne @Fmov Z.Stack,StackDimov Z.CurrentDO,StackDi
@@:BackRet

IterCV$$:;Jump to where block says. This one when there is a Control Variable
 Qry D.Rec,HasDotsjnz DotsIterCV
; Retreive CV, with test of Dropped.!!
; CV could be Exposed!!
 Up
 mov bx,D1.CV
 Move V,Vbxf
 push bx
 call NumDxBxjc Raise41p1
; It would be inefficent to use all the code of Add$$ because that checks
; LHS and then RHS. We don't need the RHS (the BY value) checked again.
; Add on BY.
 Move V2,D1.By
; AddRegs only when binary !!
 call AddRegs
 pop bx
; Store that back in CV.
 call AsgnToFsBx
CompareTO:
 Qry D.Rec,HasTojz ItNoTo
 Up; Over as assigned to CV.
; Compare with TO
; !! Not good enough to do compare with Subtract because of FUZZ<>0 case.
 Move V2,D1.To,edx
 Upcall Subtract$$
; It is possible for the result to be out of binary range.
 test V.Dtype,$Testjz ByBin
; TO value was subtracted so LEAVE when signs of result and BY are same.
 call ToDsSiCxDown
 cmp Bptr[si],'0'je ItNoTo; No LEAVE when compare equal.
 mov al,0cmp Bptr[si],'-'jne @Finc ax@@:
 xor al,D.Rectest al,1jz Leave$$
 jmp ItNoTo
ByBin:
 Down
; Assert Subtract$$ leaves eax as mantissa.
 cmp eax,ebpje ItNoTo; No LEAVE when compare equal.
; TO value was subtracted so LEAVE when signs of result and BY are same.
 mov al,V2.Signxor al,D.Rectest al,1jz Leave$$
ItNoTo:
 Qry D.Rec,HasForjz ItNoFor
; Count down FOR
 dec D.ForCount.Mantissajs Leave$$
ItNoFor:mov CursorSi,D.IterationBackRet

DotsIterCV:; To establish the CV, it is necessary to go to the top of the
; loop again, where the tails are specified.
 push CursorSimov CursorSi,D.TailsAtOn Z.Cancel,FromIterCVBack
BackToIterCV:; From DotControlVar$$ when CV resolved.
 PopJunk ax; SI pushed by DotsControlVar$$
 PopJunk ax; XCycle return link.
; Was left Up.
 Move V,Vsid
 call NumDxBxjc Raise41p1
; Add on BY.
 Move V2,D1.By
 call AddRegs
; Store that back in CV.
 Move Vsid,V
; Doesn't work for A.  NYI
 Down
 pop CursorSi
 jmp CompareTO

IterRep$$:; This is where DO n enters.
 dec D.Reps.Mantissajz Leave$$
Iterate$$:; This is where FOREVER enters.
 mov CursorSi,D.IterationBackRet

;------------------------------------------------------------------------------
; This lot are about invoke and return.
;------------------------------------------------------------------------------
comment~ If an external Rexx routine is to be kept in memory between calls
to it then it will be essential to preserve the Pcode segment, and the Symbols
segment. If it has any values it will need the pools for constants and
variables, ProgScope and VarScope(s).  If it is to do new symbol lookups
(eg for INTERPRET) or if it needs default symbol values then it will need
the Vars and Consts segments but these can be reconstructed on demand from
the Symbols segment.

So it makes sense to have the Pcode and Symbols addressed from the SysFiles
compound when dormant. For execution these are made current by copying the
segment pointers to the Zone. The Vars and Constants and scopes are then
available "on demand".
~

; Invoke is like CALL, with an extra argument to count relevant parameters.
Invoke$$:lodsb gs:[CursorSi]mov ah,-$StrideVimul ah
 add ax,StackDi; For where the arguments are.
 mov dx,mask IsFunction; And zeroes for other flags in callee level.
 jmp AsCall

; The CALL argument is the relevant label.  There may be parameters.
Call$$:mov ax,Z.CurrentDO; Parameters lie between last DO block and new level.
 z dx
AsCall:
;MASM..............................
; ax is where the callee will find its arguments.
; dx distinguishes call v invoke.
; Should not change to new level yet, by update of Z.Level, because any
; error in calling needs to be raised in the caller level.
 push axpush dx
; Wont hurt to complete some fields in the caller level, even if call fails.
 mov bx,Z.Level; The level being called from.
 move Lbx.LevelDO,Z.CurrentDO; Avoidable for CALL but code sharing with Invoke.
 lodsw gs:[CursorSi]; The callee.
; Note where to resume if we return to caller, in the caller level.
; (For simple case, CursorSi not pushed. But that complicates error case.)
 mov Lbx.Resume,CursorSi
; There are both .SIGL and SIGL.
 mov Ve.Dtype[$?SIGL],$Siglmov Ve.MantLow[$?SIGL],CursorSi
 mov Vf.Dtype[$?SIGLx],$Siglmov Vf.MantLow[$?SIGLx],CursorSi
;------------------------------------------------------------------------------
; Check that callee is callable.
;------------------------------------------------------------------------------
 mov OperandBx,ax; Target routine
 cmp Bptr Vbxe.LabelType,0jne Raise16p3; Trace-only
 mov CursorSi,Vbxe.LabelValue; Offset in Code of callee.
 TestReg CursorSijnz NotExternal
; There was no label-with-colon in the source for this name. The
; name itself is the determinant of what is called.
 mov ds,Z.Constsmove Z.Insert.Named,Vbx.Here; In case error 43.1
 Upcall BxConstmov Z.HowInvoked,sizeof FUNCTION
; Use a Bcode routine to search DOS path for the name.
External:On Z.Cancel,SourceFilescall Name2FileOff Z.Cancel,SourceFiles
 z Z.ResumeP; Done with Bcode for now.
; We have looked up the fully qualified name of the source program file.
; Address the qualified name.
 mov ds,Z.SysFileslea dx,Jbx.Keymov si,Jbx.KeyLen
 cmp si,ZeroBpjne FullName

; PATHQUALIFY could not find the relevant file.
; In non-command case, not found is error 43.1
 PopJunk axPopJunk axmov ax,MkMajMin(43,1)
 cmp Bptr Z.HowInvoked,sizeof COMMANDje @F
 mov StackDi,Z.Levelmov CursorSi,L.Resumejmp Raise
; "Routine not found" seems better than "Initializing error".
@@:dec ax; We don't have a constant to be <name>, so short msg.
; Need some initializing to prevent Raise falling over.
 z Z.Codez Z.InsLine
; We want <source> to be the unqualified file name.
 move Z.File,Z.InsUnqual,cxjmp Raise

;------------------------------------------------------------------------------
; Invoke the internal routine.
;------------------------------------------------------------------------------
NotExternal:; Make new level and fill fields.
 add StackDi,$StrideL; Is also new LevelDi
 pop L.Access; Was dx
 pop L.Arg0; Was ax
 move L.UpLevel,Z.Level; From new to old.
 mov Z.Level,LevelDi
 mov Z.CurrentDO,StackDi
; Procedures are marked at their beginning.
 cmp Bptr gs:[CursorSi],$pRaiseje @FBackRet

Raise16p3:PopJunk axPopJunk axmov ax,MkMajMin(16,3)jmp Raise16

@@:; Turn on flag for the benefit of Return$$.
 inc2 CursorSi; Length of Raise op.
 On L.Access,IsProcedure

comment~ Invocation of a PROCEDURE requires a new generation of the array that
accesses Rexx variables (aka a pool).  This cannot go on the stack because
INTERPRET can change it's size (by introducing a new variable) while the array
is active.  A possible design would put the Level block (Digits setting etc for
this call) at the header of the segment for the array but that would be
inefficient for a non-procedure.  So the actual design has a Level block in the
stack for every invocation, with that block addressing the array if the
invocation is for a procedure.

When a variable is EXPOSED there will be an item for it in the current pool,
ie current Z.VarScope array, to say 'exposed' and an item at the same position
in a caller's array saying 'not-exposed'.

Exposed lists can be dynamic so a name that has not been seen before provokes
a new item in both caller and callee pools. In this design the callee pool is
initially made without concern for that, and maybe extended later.
~

 push CursorSiz si; Supports H mode of addressing.
; Is there a recycled pool space available?
 mov cx,fs:H.SegSize; Assembles better than Hf.SegSize since offset=si=zero.
 cmp Z.PoolPool,ZeroBpjne HavePool
; Z.Vars is the array for naming variables.
; Z.VarScope is the array for the values of variables.
; They are the same size, same header.
; Make space for a copy of the latter.
 call ParaAllocAxmov ds,axjmp HaveSpace
HavePool:mov ds,Z.PoolPool
if Debug
 cmp H.SegSize,cxje @FError49Bp@@:
endif
 move Z.PoolPool,H.UpPool
HaveSpace:; At ds for cx bytes.
 call VarPoolInitpop CursorSiBackRet

VarPoolInit:; Initialise with copy of header, variables all type Dropped.
; Used for a PROCEDURE call and for a reuse of an external.
 z bxshr cx,$ShiftV
@@:mov Vbx.Dtype,$Droppedadd bx,$StrideVLoopQ @B
 z simov edx,fs:H.Hdw0mov H.Hdw0,edx
 mov edx,Hf.Hdw0+4mov H.Hdw0+4,edx
; I am not sure following is needed. It sets Link but that not needed?
 mov H.Link,Zshape.VarScope
; Procedure's pool remembers caller's pool for reinstatement at return.
; (In PROCEDURE case)
 mov H.UpPool,fs
; Zone to show the latest.
 mov Z.VarScope,dsmov fs,Z.VarScoperet

; To treat Command like an external call we have already put the callee name
; on the stack. Push where args are and not-a-function tag.
Command:push Zshape.CommandArg-$StrideVpush ZeroBp
 mov Z.HowInvoked,sizeof COMMANDjmp External
;------------------------------------------------------------------------------
; Invoke an external routine.
;------------------------------------------------------------------------------
FullName:; FileBx leads to name of compilee.
 add StackDi,$StrideL; Is also new LevelDi
 pop L.Access; Was dx
 On L.Access,IsExternal
 pop L.Arg0; Was ax
 move L.UpLevel,Z.Level; From new to old.
; We can change to the new level because even if it fails to compile that will
; count as a failure in the callee.
 mov Z.Level,LevelDi
 mov Z.CurrentDO,StackDi
 mov Z.Stack,StackDi

comment~ This is the entry for an external call.  SS is set to the Zone, with
some fields in Zone already set.  In particular Z.Level is the latest level
block, the one for this callee.  It has Arg0 set for its parameters, and the
UpLevel link. There is nothing for it to inherit from, so the rest of it has
to be initialized.

Z.SysFiles in the Zone is set and in particular FileBx is the item in that
segment for the qualified name of the called source file.

~

comment~ Since we are operating with a single copy of Zone, there is quite a
lot of state to save when starting on a new program source file.
The resume address and the level of DO are already saved since they are
needed in non-external case. Also saved (in the level for the callee)
are the pointer to the caller level and the pointer for the args.
We don't need to save things that are valid across the whole execution, eg
SysFiles and Radix. We don't need to save things that are to do with the
compilation process because we are executing the call. We don't need to save
things
that are held in level blocks, eg the setting of conditions. We don't need to
save execution things that are inactive when invoke is possible, eg the PARSE
work values. I'm not sure whether it is necessary to save the randomizing Seed
but it is probably best to.

The segments relating to the caller need to be saved (or reconstructed on
return/demand).  The ones that represent compilation, Symbols and Pcode, are
saved in the SysFile entry for the DOS name of the caller source file. (The
latest version is stored in case this call is from an INTERPRET.) The segments
that represent values, VarScope and ProgScope, are saved in the caller level
block. The segments needed for lookup, Var and Consts, are stored in the
SysFile entry but lost on compaction and reconstructed on demand.(NYI)

~
; Exit is to scan for Level, so as to actually Return.

; Raise to know.

 mov LevelSi,L.UpLevel
; Outermost level has no segments to save.
 cmp LevelSi,ZeroBpje @F
 call ZoneToLevelmov Z.VarScope,csmov Z.ProgScope,cs
@@:
 call SetInherit

; The Vshape part of the item (used for buffer when a data file) is not used
; in the case of source, except as a flag for whether this is first sighting
; of the file.
 cmp Vbx.Dtype,$Droppedjne KnownExternalmov Vbx.Dtype,$NullString
; This is first sighting, so compile the source.
; ASCIIZfy.
 mov si,Jbx.KeyLen
 z clxchg cl,Bptr(Jbx.Key[si])
; Attempt to open the source file.
 mov ax,MkMajMin($DosOpen,0)int 21h
 mov Bptr(Jbx.Key[si]),cl; Un-ASCIIZfy
 mov Z.SourceHandle,ax
 jnc OpenedOK

; Get extended error. Don't care if es,ds changed.
 push dxpush sipush di
 z bxmov ah,$DosGetErrorint 21h
 pop dipop sipop dx
; if al==4 No handles left.
 cmp al,4jne @Fmov dl,$DescFilesjmp Raise5p1@@:
; else some other initialization error.
 mov Z.Insert.Hex,almov ax,MkMajMin(3,1)mov dl,$Desc59Hjmp Raise

if Solid
; 'E' and 'S' would do except for result of bif FORM()
$Reserved db ".MN .RS .RESULT .RC .SIGL;"
          db "1:2:3:4:5:6:7:8:9:A:B:;"
          db "9 0'' 'ENGINEERING' 'SCIENTIFIC';"
          db "ARG . RESULT RC SIGL ;push qualify('CRXREXX.QUE');"
$ReservedLen equ $-$Reserved
endif

ZoneToLevel:; Saves Zone contents before External call.
 push ax
 move Lsi.ProgScope,Z.ProgScope
 move Lsi.VarScope,Z.VarScope
 move Lsi.File,Z.File
 pop ax
 ret

OpenedOK:
 mov Z.File,FileBx; Not earlier or <source> in msgs would be wrong.

; Setup segments for Symbols etc.
; These sizes are not crucial, they are just granularity for segment expansion.
 mov cx,4096; Bytes.
 mov bx,4096-2; Trigger for when to extend.
 mov SegOffDi,Zshape.Symbolscall InitSegDs
; Setup segment for Code
 mov SegOffDi,Zshape.Codecall InitSegDs
; Setup segment for Vars
 mov cx,127*16mov bx,127*16-2*$StrideV
 mov SegOffDi,Zshape.Varscall InitSegDs
; VarScope is a shadow of Vars.
 mov SegOffDi,Zshape.VarScopecall InitSegDs
; Setup segment for Consts
 mov SegOffDi,Zshape.Constscall InitSegDs
; Make offsets into ProgScope multiples of two but not of eight.
; And add a spare item for $Omitted.
 mov Wptr Hd.Avail,$StrideV+$SizeConstsHeader
; Set up ProgScope segment which contains space for $?OUTCOME etc.
 mov cx,127*16mov bx,127*16-2*$StrideV
 mov SegOffDi,Zshape.ProgScopecall InitSegDs
; Make offsets into ProgScope two modulo eight.
; And add a spare item for $Omitted.
 mov Wptr Hd.Avail,$StrideV+$SizeConstsHeader
if MemCheck
 call DosMemCheck
endif
;------------------------------------------------------------------------------
; Initializing of names for Lookup is done by an INTERPRET of $Reserved string.
;------------------------------------------------------------------------------
 call UpStack
 mov V.Sg,cs
 mov V.Pt,offset $Reserved
 mov V.Len,$ReservedLen
 mov V.Dtype,$AwayString
 mov gs,Z.Code
 call Interpret1; Interpret with labels allowed, no execution.
; Any code made from Reserved is unwanted.
 mov Hg.Avail,$StrideH
; The labels were just to reserve some slots. Lookup should not see them.
 z simov ds,Z.Constsz H.Labelsz H.TreeBin
; Make the constant for Omitted special.
; Omitted to have value of null string and unique datatype.
 move Vsid.Here[$?Omitted],Vsid.Here[$?Null]
; Last stream encountered in $Reserved was for Rexx queue.
 move Z.Queue,Z.Stream
 call ProgScopeInit
 mov ds,Z.SysFiles
Jett:; Just a label for debugging.
if MemCheck
 call DosMemCheck
endif
 jmp Compiler

ProgScopeInit:; SI is set zero
 push StackDi
 mov ds,Z.ProgScope
 z si
 mov di,$StrideH
@@:mov Bptr[di],0inc dicmp di,$?Ninejb @B
 mov Vsid.Dtype[$?Omitted],$Omitted
; Set the type of some SysVars.
 mov Vsid.Dtype[$?RESPONSE],$NullString+1
 mov Vsid.Dtype[$?CLAUSETIME],$NullString
 mov Vsid.Dtype[$?STARTTIME],$NullString
 mov Vsid.Dtype[$?RESULT],$NullString
 pop StackDi
 ret

KnownExternal:; Invoke of something previously compiled.
 move Z.File,FileBx
 move Z.Symbols,F.Symbols
 move Z.Code,F.Code
 move Z.Consts,F.Consts
 move Z.ProgScope,F.ProgScope
 move Z.Vars,F.Vars
 call ProgScopeInit
; !! If only one copy of ProgScope values, need .MN etc in Level.
if 0
 We could have reconstructed ProgScope from Symbols
; Size of Z.ProgScope is the same as Z.Consts.
 mov fs,ax!!mov cx,Hf.SegSize
 call ParaAllocAxmov ds,axmov Z.ProgScope,ax
; Headers are the same except for Link field.
 mov edx,fs:H.Hdw0mov H.Hdw0,edx
 mov edx,fs:H.Hdw0+4mov H.Hdw0+4,edx
 mov H.Link,Zshape.ProgScope
; Fill in the values of the constants.
endif
; Make Z.VarScope for the callee.
; Size of Z.VarScope is the same as Z.Vars.
 mov fs,axmov cx,Hf.SegSize
 call ParaAllocAxmov ds,axmov Z.VarScope,ax
 call VarPoolInit
 mov Hf.UpPool,ZeroBp; Unlike PROCEDURE
 jmp StartExecution

Result$$:DownBackRet; Lose unwanted result from called bif.

Returns$$:
 push V.Mantissapush V.ExpAnd
 mov LevelDi,Z.Level; Lose DO's at this level.
 Qry L.Access,IsFunctionjz CallResult
 call ReturnX
 Uppop V.ExpAndpop V.Mantissa
 BackRet

CallResult:
 call ReturnX
 Uppop V.ExpAndpop V.Mantissa
; Set RESULT special variable.
 Move Vf[$?RESULTx],V
; Set .RESULT reserved variable.
 Move Ve[$?RESULT],V
 Down
 BackRet

Return$$:mov LevelDi,Z.Level; Lose DO's at this level.
; Check for RETURN when called as a function.
 Qry L.Access,IsFunctionjz ReturnX
; Msg 45.1 happens in the callee. (External has 44.1 in caller)
 Qry L.Access,IsExternaljnz PlainRet
; Recover caller name.
 mov LevelDi,L.UpLevel; Invoker block. Assert cannot be zero.
 mov CursorBx,L.Resume; Invoker holds resume point.
 mov ArrayBx,gs:[CursorBx-2]
 mov ds,Z.Constsmove Z.Insert.Named,Vbx.Here
 mov ax,MkMajMin(45,1)jmp Raise

; If this is a procedure folding, there will be a change of Z.VarScope.
ReturnX:Qry L.Access,IsProcedurejz PlainRet
; Current scope goes on freespace chain.
 mov ax,Z.PoolPool
 xchg ax,Hf.UpPool
 mov Z.PoolPool,fs
; Caller's pool becomes current.
 mov Z.VarScope,ax
 mov fs,ax
PlainRet:
; Drop RESULT special variable.
 mov Vf.Dtype[$?RESULTx],$Dropped
; Drop .RESULT reserved variable.
 mov Ve.Dtype[$?RESULT],$Dropped
 mov LevelSi,L.UpLevel; Invoker block.TestReg LevelSijz Exit$$
 mov Z.Level,LevelSi
; Some Zone restoration from callers stuff if an External is being left.
 Qry L.Access,IsExternaljz @F
 move Z.ProgScope,Lsi.ProgScopemov ProgEs,ax
 move Z.VarScope,Lsi.VarScopemov fs,ax
 move Z.File,Lsi.File,FileBxmov ds,Z.SysFiles
 move Z.Symbols,F.Symbolsmove Z.Code,F.Codemov gs,ax
 move Z.Consts,F.Constsmove Z.Vars,F.Vars
@@:
; Return can have the effect of altering the current digits().
; But only if the invokee(s) altered digits().
 Qry L.Access,DigitsSetjz @F
 call DigitsChange
@@:
; Lose arguments and level block of completing routine.
 mov StackDi,L.Arg0move Z.CurrentDO,Lsi.LevelDO
 mov CursorSi,Lsi.Resume; Invoker holds resume point.BackRet

Exit$$:; Exit has an optional argument.
 z cxcmp StackDi,Z.CurrentDOje @F
 inc cxpushd V.ExpAndpushd V.Mantissa
@@:push CursorSi
; Go up the Level chain to the current External
ExitUp:mov LevelSi,Z.Levelmov StackDi,Lsi.Arg0
if Debug
 TestReg LevelSijnz @FError49Bp@@:
endif
 Qry Lsi.Access,IsExternaljnz @F
 move Z.Level,Lsi.UpLevel,LevelSijmp ExitUp
@@:move Z.CurrentDO,Lsi.LevelDO
; Is this the outermost external (that came as a command)?
 cmp Lsi.UpLevel,ZeroBpje @F
 pop CursorSiTestReg cxjz Return$$; EXIT with no argument becomes RETURN.
 Uppop V.Mantissapop V.ExpAndjmp Returns$$; EXIT(...) becomes RETURN(...)
@@:; True exit. Can only return a byte (in AL) as result.
if 0
; Close all files.
 mov ds,Z.SysFiles
 mov dx,Hd.Avail
 mov bx,$StrideH; Steps through files.
NextFile:call CloseBx
 Wrong see Compaction
 add bx,$StrideF
 add bx,Jbx.KeyLenadd bx,$StrideJ
 cmp bx,dxjb NextFile
endif

Exit:
 mov al,$SerialNonecall Serialize
 mov bx,Z.Dumper
 mov ah,$DosCloseint 21h
ExitDOS:mov ah,$DosExitint 21h

;------------------------------------------------------------------------------
; Here are the other operators for expressions.
;------------------------------------------------------------------------------
comment~
Aug99 plan is to have $AwayNumber as a general form for numbers and have a
binary format as an optimization, used for values that will fit in the 8 byte
binary format.  ($AwayNumber is currently being done as a char string by ARITHOP
but there is potential to go to binary.)

This Jan 2000 rewrite of the problems caused by changing of NUMERIC settings.

Problem #1:  For performance we plan to keep arithmetic results (eg J+1) in
binary when the value allows that. Problem is that eventual use may be a
string context (eg K=J+1;say K).  The conversion to string needs to know
about the NUMERIC settings as they were when the value was created. (They
may have changed since.)  There isn't room to keep this info with the value
so conversion has to assume the normal (default) settings of 9 digits and
SCIENTIFIC form.  So if the actual settings are different (strictly speaking,
would lead to a different string result) then we cannot keep an arithmetic
result as binary.  This isn't an awful problem because most arithmetic will
be at normal settings and values with lots of digits could not be held in
eight-byte binary anyway.

Problem #2:  We would like to convert constants, ie 77 in ABC+77, to binary
at compile time. But we cannot simply do that because 77 has value 8E1 at
digits one.  There is a theoretical approach of waiting until digits<9 happens
then reworking the constants but that would mean knowing which were BIF
arguments since these don't need reworking.

Problem #3:  A number held in binary will have been made at digits nine. If
used at digits less than nine it will have to be converted to string and then
back to number, the latter conversion making any LOSTDIGITS adjustment.

There are two reasonable implementations. (1) When digits changes to below nine
find all binary values and make them string.  (2) Check digits setting before
use of each binary value.

Problem #4:  Changes in digits() should be shielded from the Bifs, which have
their own precision rules.

About ArithOp.  The ArithOp routine from the standard, implemented as Bcode,
is our way of doing the general case of Rexx arithmetic.  The standard runs
ArithOp with digits setting "as necessary"; in practice the setting of the
caller seems sufficient.  Explicitly and implicitly ArithOp recurses, eg
division done by repeated subtraction.  This recursion has to end, by
ensuring that single digit plus single digit does not recurse. To avoid
complication when digits()=1, when 7+7\=14 but LOSTDIGITS, it seems best to
provide a CONFIG_ADD for the single digit case.

ArithOp is not intended to be speedy.  The implementation would be faster
for digits()\=9 if the binary Add$$ routine was used for values that fitted
in 8 bytes, even when the current digits() was not nine.  For this to work
some extra tests are needed.  Binary values coming into the arithmetic have
to be checked for possible LOSTDIGITS. Binary results have to be checked
for possibility that character conversion would not give the same result
as digits nine would.  So having these checks is a trade-off of slower
execution of normal arithmetic in favour of speeded non-nine arithmetic.


The interesting coding for Add$$ etc.is when both operands come as binary.

Shifts needed to bring operands into alignment can lead to an intermediate
result which needs to be rounded to bring it into digits() range. (Although
64 add/subtract is enough for intermediate results whatever the shifts.)

There needs to be fast access to the power of ten that determines if rounding is
necessary. This costs a test on RETURNs, looking for change of digits().

~
; Aug 99 - clumsy interface to ArithOp since future undecided.
Raise41p2BLM:int 3jmp Raise41p2
ArithRight:jc Raise41p2BLM
ArithGeneral:
 mov dl,gs:Bptr[CursorSi-1]push CursorSi
 Downcall ToDsSiCxjmp @F

Raise41p1BLM:int 3jmp Raise41p1
ArithLeft:jc Raise41p1BLM
 mov dl,gs:Bptr[CursorSi-1]
ArithDl:push CursorSi; Entry with lower already string and DL for the operator.
@@:Upcall ToDsSiCx
 Upmov V.Dtype,$NullString+1
 mov V.String,'>'; All compares
 cmp dl,$pAddjne @Fmov V.String,'+'@@:
 cmp dl,$pSubtractjne @Fmov V.String,'-'@@:
 cmp dl,$pNegatejne @Fmov V.String,'-'@@:
 cmp dl,$pPositivejne @Fmov V.String,'+'@@:
 cmp dl,$pMultiplyjne @Fmov V.String,'*'@@:
 cmp dl,$pDividejne @Fmov V.String,'/'@@:
 cmp dl,$pIntDividejne @Fmov V.String,'%'@@:
 cmp dl,$pRemainderjne @Fmov Wptr V.String,'//'inc V.Dtype@@:
 cmp dl,$pPowerjne @Fmov Wptr V.String,'**'inc V.Dtype@@:
 call HeritageDimovzx eax,L.Digitsmov dx,L.Fuzzpop StackDi
 cmp V.String,'>'jne @Fsub ax,dx@@:
 Upmov V.Mantissa,eaxmov V.ExpAnd,ebp
 pop CursorSipush CursorSi; Might be needed for Msg
 mov dx,offset ARITHOP$$call LinkBcodemov Z.Stack,StackDi
 pop CursorSi
if Debug
 CheckType
 int 3
@@:
endif
; We do some conversions at compile time.
 mov ProgEs,Z.ProgScope
 cmp Z.Scanp,ZeroBpje @F
 mov SymbolsEs,Z.Symbols
@@:BackRet

; The binary operators find their LHS as the older parameter and their RHS
; as the latest parameter.
; Add, subtract, and numeric compare are similar.
; If the values are too big for the precision we must use ArithGeneral to
; raise LOSTDIGITS. This check is in NumDxBx
Add$$:; Required to check left one first.
 Downcall NumDxBxjnz ArithLeft
 mov ecx,edxmov eax,ebx
 Upcall NumDxBxjnz ArithRight
 Down
; Now we know it is to be done in binary, the predominant case.
AddRegs:;LHS in ecx:eax (V originally)   RHS in edx:ebx (V2 originally)
; Easy case with both signs and exponents the same.
 cmp ecx,edxjne AddTest
; Result cannot be zero unless both operands were, in which case exponent
; already zero.
 add eax,ebxcmp eax,Z.Ceilingjae Round32; Unusual
AddSubEax:mov V.Mantissa,eax
AddSubNull:
; If not SCIENTIFIC 9, convert to char because if char needed later the
; numeric settings may have changed.
 cmp Z.UseGeneral,ZeroBpje AddS9b
; Don't want to do this in Bcode because (1) numeric setting won't lower and
; (2) assumptions of S9 are made.
 cmp Z.ResumeP,ZeroBpjnz AddS9b
 push CursorSi
 call ToDsSiCx
 pop CursorSi
AddS9b:BackRet; Does not guarantee registers match V.

Round32:;32 bit result to be roundedz edxjmp Acc64

; Mantissa shifted out of significance is the same as being zero.
AlignNoOver:add edx,ecxmov ebx,eax
RetEdxEbx:mov V.ExpAnd,edxmov V.Mantissa,ebxBackRet

AddTest:; Still doing AddRegs, after some cases handled.
; Test zero mantissas.
 cmp ebx,ebpje AddSubNull; LHS+0 case.
if 0
 Problems with rounding.
cmp eax,ebpje RetEdxEbx
endif
; If the signs differ, change sign and change to a subtract.
 push edxxor edx,ecxtest dl,1pop edxjz @Fxor dl,1jmp SubRegs@@:
; Signs are now the same but exponents will not be.
 cmp ecx,edxjge @F; First make LHS have the large exponent.
; Simplest is to change A+B to B+A.
 xchg edx,ecxxchg ebx,eax
@@:sub ecx,edx; ecx is non-negative, twice the difference of exponents.
; If the difference is large there will be no overlap of mantissae
; and the big magnitude operand is the result.
 cmp ecx,Z.TwiceDigitsjge AlignNoOver
; Multiply by appropriate power of ten. (ecx is double shift required)
 push edxmul Ycx2.N1; Indexing does a second doubling.
; It may be we are just adding cents to dollars and the result is going to fit
; in 32 bits but more likely we are doing a scientific calculation which has
; built up nine digits. So probably best just to do things with 64 bits(?).
 pop ecxadd eax,ebxadc edx,ebp
; Assert ebx+eax cannot have result zero. (So pushed edx remains the exponent)
; Does result need rounding? Note that V & V2 are intact, for a possible msg.
 cmp edx,ebpjne Acc64
AddPos32:cmp eax,Z.Ceilingjae Acc64
PostAcc64:Move VBackRet

OneMore:z edxjmp ChangeExpon

ToArithGeneral:Upjmp ArithGeneral

Acc64:; The 64 bit accumulator edx:eax has a result that is too big for
; Z.Ceiling.
; It may need rounding, or if current digits >9 it needs rework as long.
 cmp Z.Digits,9ja ToArithGeneral
; The exponent of the result is in ecx. (Doubled form)
 push CursorSi
; Something with BSR instruction and lookup might be quicker than a loop here.
; We are going to have to reduce the Mantissa and bump the exponent at least
; once. Do initially divide with enough to zero edx of edx:eax.
ChangeExpon:z si
@@:add ecx,2add si,4cmp edx,Ysi.N1jae @B
 div Ysi.N1; Division by this power of ten will give result in 32 bits.
; That took (edx*2**32+eax)*(ecx/2) to eax*10**(N+ecx/2) with edx remainder.
 cmp eax,Z.Ceilingjae OneMore
; We have enough significant decimals to the eax number. edx decides rounding.
 add edx,edxcmp edx,Ysi.N1jb @Finc eax
; It is just possible accum is now exactly over limit
 cmp eax,Z.Ceilingje OneMore
@@:pop CursorSi
; Quick test accepts most exponents.
 cmp ecx,Y.ExponHijg TestExpon
 cmp ecx,Y.ExponLojg PostAcc64

comment~ The exponent is held in binary, representing a decimal exponent.
Testing is not as simple as testing -999999999 to +999999999 because
(a) the mantissa is held as integer so giving the mantissa a decimal point in
the correct place increases the exponent and (b) Engineering notation can reduce
the exponent. However, these effects are limited so we can be sure most
exponents are OK by testing a smaller range, Y.ExponLo to Y.ExponHi.
When that test is inconclusive, the simplest thing is to convert to decimal and
test that. For that to work, ToDsSiCx needs to cope with exponents up to 2**32.
~
TestExpon:; The quick check on V. has already been made, so ecx is extreme.
; Need to keep original LHS for possible message.
 pushd V.ExpAndpushd V.MantissaMove V
 push CursorSipush ecxcall ToDsSiCx
@@:dec cxinc sicmp Bptr[si],'E'jne @Bmov dl,Bptr[si+1]
 cmp cx,$Limit_ExponentDigits+1pop ecxpop CursorSi
 pop V.Mantissapop V.ExpAndja PostAcc64
; 40.9 and 41.7 occur on loading operands for input to operations.
; 42.1 and 42.2 occur when testing the output of operations.
 mov ax,MkMajMin(42,1)cmp dl,'+'je Raiseinc axjmp Raise

Subtract$$:; Required to check left one first.
 Downcall NumDxBxjnz ArithLeftmov ecx,edxmov eax,ebx
 Upcall NumDxBxjnz ArithRightDown

SubRegs:; Read the code for Add first.
 cmp ecx,edxjne SubTestsub eax,ebxjz SubZero
 jl @Fcmp eax,Z.Ceilingjb AddSubEaxjmp Round32
@@:xor cl,1neg eaxcmp eax,Z.Ceilingjae Round32
SubAddEcxEax:mov V.ExpAnd,ecxjmp AddSubEax

SubTest:cmp ebx,ebpje AddSubNull
; If the signs differ, change sign and change to an add.
 push edxxor edx,ecxtest dl,1pop edxjz @Fxor dl,1jmp AddRegs
SubRegsCmp:; Here from compare, avoiding some tests.
@@:cmp ecx,edxjge @F
; Simplest is to change A-B to (-B)-(-A), so exponents ordered.
 xor cl,1xor dl,1xchg edx,ecxxchg ebx,eax
@@:sub ecx,edxcmp ecx,Z.TwiceDigitsjge AlignNoOver
 push edxmul Ycx2.N1
 pop ecxsub eax,ebxsbb edx,ebpjns SubPos
; Subtract is harder than Add, since zero and negative possible.
 xor cl,1neg eaxpushfneg edxpopfjnc @Fdec edx@@:
SubPos:cmp edx,ebpjne Acc64cmp eax,ebpjnz AddPos32
SubZero:mov V.ExpAnd,ebpjmp AddSubEax

;------------------------------------------------------------------------------
; Conditional Pcode jumps and Boolean results here.
;------------------------------------------------------------------------------
if 0
This proved to be a lot slower. Kept just for interest.
comment~ The way to do conditionals without writing into code is to use an
array of sequences like (jb @Fxax CursorSi@@:ret) and branch to one of them.
 (sete alret) for boolean results.  However, this version writes to code.
~
Eq$$:Ne$$:Lt$$:Le$$:Ge$$:Gt$$:
; Alter code so that eventual test, after comparison, is the intended
; conditional jump.
 mov al,cs:Conditionals[bx-$pEq]mov Bptr cs:Conditional,al
; SetFlags is used from elsewhere as a subroutine.
SetFlags:; Set hardware flags from compare and also ax from Pcode.
FlagsSet:lodsw gs:[CursorSi]
....
; User wants fallthru on Pcode if the test succeeds, else continuation at ax.
Conditional:je @Fmov CursorSi,ax@@:BackRet
endif

; CmpGen is the general test for whether non-strict is char or arith compare.
; Already filtered off (at compile) case where one argument is non-arith const.
; Already filtered off case of both in binary.

StringC:Up; RHS was number but LHS proved not.
 Move V; Non-binary form of RHS
 jmp StringCompare

CmpGen2:; RHS is bin (and was originally), LHS may be convertible.
 call NumDxBxjnc CmpArithUpjmp StringCompare

; No msgs so we can look at rhs first.
; This is a touch clumsy because NumDxBx is destructive - usually conversion
; is desirable if possible - but for comparison we want conversion only
; if both will convert.
CmpGen:Move ,Vcall NumDxBxjc StringCompare
; RHS is some sort of numberDowncall NumDxBxjc StringC
; Both some sort of arith.  ArithGeneral if either out of range for Binary.
; Or if FUZZ<>0
CmpArith:jnz @F
; 2011 UseGeneral does not apply if both binary.
; cmp Z.UseGeneral,ZeroBp
; jne @F
 test V2.Dtype,$Test
 jz FromCmpGen; For binary Arith compare after conversion(s).
@@:Up
 call ArithGeneral
 call NumDxBxjz MantPare
; Difference was still not binary.
 lds bx,V.Fr
 z V.ExpAndz V.MantHigh
 cmp Bptr[bx],'-'jne MantPare
 inc V.Signjmp MantPare

Eq$$:Ne$$:Lt$$:Le$$:Ge$$:Gt$$:
; Convert particular operator to place in Rejumps.
 shl bx,2add bx,Rejumps-(4*$pEq)push bx
SetFlags:; Set hardware flags from compare and also ax from Pcode.
; Is it worth a quick test for the number v number case? (Avoids CmpGen)
 cmp Z.UseGeneral,ZeroBpjne CmpGen
 test V.Dtype,$Testjnz CmpGenDowntest V.Dtype,$Testjnz CmpGen2
FromCmpGen:; When conversions to binary worked.
 Move ,Vmov edx,V2.ExpAndmov ebx,V2.Mantissa
; RHS in edx:ebx LHS in ecx:eax
 xor ecx,edxjz EasyPare; Quick if exponents and signs are the same.
 test cl,1jnz EasySign; Quick if signs differ.
 mov ecx,V.ExpAnd
; Subtract and test result will work but may be overkill.
; Signs are the same, exponents differ.
;Exponent is irrelevant if comparison is with zero.(Nearly 1/4 of reached here)
  cmp ebx,ebpje EasyPare
; Subtract and test result.
 call SubRegsCmp
; Compare Mantissa with zero.
MantPare:mov eax,V.Mantissaz ebx
EasyPare:test V.Sign,1jz @Fxchg eax,ebx@@:
 Downcmp eax,ebx
; Interpreted branch conditional.
; Flags reflect relation.
 lodsw gs:[CursorSi]
; User wants fallthru on Pcode if the test succeeds, else continuation at ax.
; We jump to some jump conditional.  (Or return if called.)
 ret
EasySign:; Deduce result from the (differing) signs.
 Downmov ax,1test dl,1jnz @Fxchg ah,al@@:cmp al,ah
 lodsw gs:[CursorSi]
 ret

;------------------------------------------------------------------------------
; The C series of compares are known from compile time to be string compares.
; They join the general case once the hardware flags are set.
; The S for strict series are similar.
; The _ series of Bcode operators is similar but with one byte jump addresses.
;------------------------------------------------------------------------------
@@:Downcall ToDsSiCxUpjmp @F

Ceq$$:Cne$$:Clt$$:Cle$$:Cge$$:Cgt$$:
 shl bx,2add bx,Rejumps-(4*$pCeq)push bx
StringCompare:; Space traded for speed.
 mov bx,Attributes; For potential XLAT
 push CursorSi
; If the left one isn't a string then better convert it now so that no
; compaction threat from ToDsSiCx of it.
 test V0.Dtype,$Testjz @B
@@:call ToDsSiCx
 JcxzQ FromStripR
; All my blanks rank no higher than plain blank so quick test is possible.
 mov dx,FromStripR
 cmp Bptr[si],' 'jbe StripB
 push siadd si,cxdec sicmp Bptr[si],' 'jbe StripEpop si
FromStripR:
 mv es,dspush sipush cx
 Downcall ToDsSiCx
 JcxzQ FromStripL
 mov dx,FromStripL
 cmp Bptr[si],' 'jbe StripB
 push siadd si,cxdec sicmp Bptr[si],' 'jbe StripEpop si
FromStripL:pop bxpop ax
FromStrict:Down
; Now strict comparison of the lhs(ds:si:cx) with rhs(es:ax:bx)
 push StackDimov di,axmov ax,cx
; Change cx to shared length.
 cmp bx,cxjg @Fmov cx,bx@@:
 cmp bp,bp; Zero flags in case cx=0.
 repe cmpsbjne @F
; Equal over shared length. Comparison now on lengths.
 cmp bx,ax
@@:; Flags reflect relation.
 mov ProgEs,Z.ProgScope
 pop StackDipop CursorSi
 lodsw gs:[CursorSi]
 ret

; Remove all types of blank from both ends of Ds:Si:Cx
StripB:lodsbXlatBDLSjnz @FLoopQ StripBjmp dx
@@:dec si
push siadd si,cxdec si
StripE:std
@@:lodsbXlatBDLSjnz @FLoopQ @B
@@:cldpop sijmp dx
Seq$$:Sne$$:Slt$$:Sle$$:Sge$$:Sgt$$:
; Convert particular operator to place in Rejumps.
 shl bx,2add bx,Rejumps-(4*$pSeq)push bx
StrictFlags:push CursorSicall ToDsSiCxmv es,dsmov ax,simov bx,cx
 Downcall ToDsSiCxjmp FromStrict

; The prefix to a comparison operator means the result is to go to the
; stack rather than used for a conditional jump.
; It would have been simpler to reserve a zero value of jump to mean Boolery
; but we don't want to add a test to the more frequent case.
; There is shared code for doing the comparison, entered at different places
; for strict and non-strict.
; That code ends with a jump to something it pops.  For conditional branch
; that jump leads to a conditional jump instruction. For Bool$$ it leads
; back to BoolBack.
Bool$$:mov bl,gs:[CursorSi]
 cmp bl,$pSeqjae BoolSC
; Stride is eight in the table we will eventually use. Stride of $pXXX is two.
 shl bx,2push bxcall SetFlags
BoolBack:; Hardware flags reflect the relation.
 lea CursorSi,(-1)[CursorSi]; Non-existent target word was loaded.
 pop bxlea bx,(Boolery-4*$pEq)[bx]
SetV:UpCaremov V.ExpAnd,ebpmov V.Mantissa,ebpjmp bx

BoolSC:cmp bl,$pCeqjae BoolC
 add bl,($pEq-$pSeq)shl bx,2push bxpush BoolBackjmp StrictFlags

BoolC:
 add bl,($pEq-$pCeq)shl bx,2push bxpush BoolBackjmp StringCompare
_Eq$$:_Ne$$:_Lt$$:_Le$$:_Ge$$:_Gt$$:
; Convert particular operator to place in Rejumps.
 shl bx,2add bx,Rejumps-(4*_Eq)push bx
 call SetFlags; Hardware flags reflect the relation.
; That code assumed two-byte jump argument so step back a byte.
Relatives:pushfdec CursorSiz ahdec axjs @Fadd ax,CursorSipopf
 ret; To Rejumps.
@@:; We use zero relative jump to mean Boolery.
 popfpop bxlea bx,(BooleryRejumps)[bx]jmp SetV

_Seq$$:_Sne$$:_Slt$$:_Sle$$:_Sge$$:_Sgt$$:
; Convert particular operator to place in Rejumps.
 shl bx,2add bx,Rejumps-(4*_Seq)push bx
 call StrictFlagsjmp Relatives

;------------------------------------------------------------------------------
;
;------------------------------------------------------------------------------
Multiply$$:Downcall NumDxBxjnz ArithLeftmov ecx,edxmov eax,ebx
 Upcall NumDxBxjnz ArithRightDown
; StackDi is at the LHS & Result. LHS in eax:ecx RHS in ebx:edx
; Signs & Exponents by add of (Exponent*2 + Sign) unless both negative.
; Both negative made into both positive.
 test cl,1jz @Ftest dl,1jz @Fdec cxdec dx@@:add ecx,edx; Exponent result.
 mul ebxjc Acc64
MagTest:
 cmp eax,Z.Ceilingjae Acc64
 cmp ecx,Y.ExponHijg TestExpon
 cmp ecx,Y.ExponLojl TestExpon
 Move V
 BackRet

Check34:; Leaves V. with rhs, bx as rhs.
 Downcall ToWholeEbxjc Raise34p5
 dec ebxjz @Finc ebxjnz Raise34p5
@@:Up
Check34A:
 call ToWholeEbxjc Raise34p6mov ax,bx
 dec ebxjz @Finc ebxjnz Raise34p6
@@:Downmov bx,axret

Xor$$:call Check34
Xorx:xor Bptr(V.MantLow),blBackRet

Or$$:call Check34or Bptr(V.MantLow),blBackRet

And$$:call Check34and Bptr(V.MantLow),blBackRet

Not$$:call Check34AUpmov bl,1jmp Xorx

; NUMERIC settings. When the settings change, all the constants have to be
; scanned to be sure that only those convertable both ways are held as binary.
; Also if Digits<>9 or Fuzz<>0 we need to use different operators.

Form$:push CursorSi; Parameter is the VALUE.
; Test first character of the parameter.
 call UpperFirstAh
 cmp ah,'E'je NewForm
 cmp ah,'S'jne Raise33p3
NewForm:call HeritageDimov L.Form,ah
FormRet:call ZoneNumerics
FormRetx:pop StackDiDownpop CursorSiBackRet

; Routine sets carry if value not whole >= zero.
ToWholeEbxGE:call ToWholeEbxjc @Ftest V.Sign,1jz @Fstc@@:ret

; Set up for <value> inserts that is actually value of Digits().
DigInsertz:xchg ax,bx
; AX for second <value> of msg.
DigInsertx:mov V.MantLow,axmov Z.Insert.Digits,bxjmp Raise33p1

Numeric$$:mov bl,Bptr gs:[CursorSi]inc CursorSijmp Numeric$[bx]

if Solid
Numeric$:
 dw Digits$
 dw Fuzz$
 dw Form$
endif

Digits$:push CursorSi;Defaulted parameter was added in making Pcode.
 call ToWholeEbxGEjc Raise26p5
; New Digits, test range.
 cmp ebx,$Limit_Digitsja Raise33p2mov ax,Z.Fuzzcmp bx,axjbe DigInsertx
 call HeritageDimov L.Digits,bx
; If Digits() changed we need to keep the Zone up-to-date, etc.
 call DigitsChangejmp FormRetx

DigitsChange:;Also used at Return$$push di
; Z.Digits is what we have been running at.
; The Level has been set to desired Digits.
 mov LevelDi,Z.Levelmov bx,L.Digitsmov dx,Z.Digits
 cmp bx,dxje DigitsSame
 On L.Access,DigitsSet
 call ZoneNumerics
DigitsSame:pop diret

; Values in a level block which are normally inherited are not inherited when
; this is an external call.
SetInherit:mov LevelDi,Z.Level
 Assert (Lshape.Inherit-Lshape.Digits) mod 4 eq 0
 mov cx,(Lshape.Inherit-Lshape.Digits)/4
 mv es,sspush LevelDilea di,L.Digitsz eaxrep stosdpop LevelDi
 mov L.TraceLetter,'N'mov L.Digits,9mov L.Form,'S'On L.Access,InheritDone

ZoneNumerics:; The Zone is kept showing current settings.(Speeds up arithmetic.)
; Source of settings is the current Level.
 push ecxpush eaxmov ecx,L.DigitsFuzzmov Z.DigitsFuzz,ecx
 movzx ecx,cxadd ecx,ecxmov Z.TwiceDigits,ecx
 z Z.UseGeneral
 Off Z.Program,NotS9
 cmp cx,18jna @Fmov cx,18@@:
 je @FOn Z.Program,NotS9inc Z.UseGeneral@@:
; FUZZ<>0 is rarely used. It won't hurt to generalize all operations then,
; even though only compares are affected.
 cmp Z.Fuzz,ZeroBpjne Fuzzy
 cmp L.Form,'S'je @F
Fuzzy:On Z.Program,NotS9inc Z.UseGeneral@@:
 movzx ecx,cxmov eax,Ycx2.N1mov Z.Ceiling,eax
 mov eax,Ycx2.N1-4mov Z.DivBreak,eax
 pop eaxpop ecxret

Fuzz$:push CursorSi;Defaulted parameter was added in making Pcode.
 call ToWholeEbxGEjc Raise26p6
; New Fuzz, test bound.
 movzx eax,Z.Digitscmp ebx,eaxjae DigInsertz
; Keep the Zone up-to-date
 call HeritageDimov L.Fuzz,bxjmp FormRet

comment~ We want to put the dividend to the significant end of edx:eax so as to
get most digits in the result.  But if too far that way, the result may not fit
in 32 bits when divisor is small.  Could work out how far ebx needs change to
make it bigger than eax.  However, an algorithm that tries to develop all the
digits in one shot only works well for something like 1/3 as opposed to 6/3.
For 6/3 it will lead to a number ending with lots of zeros that have to be
pruned off (a division each).  Seems better to try for a few digits at a time.

So increase dividend until bigger than divisor.  Do a divide.  Done if remainder
zero.  Done if enough digits.  Multiply result-so-far and remainder until
remainder bigger than divisor (exit if enough digits). Iterate with remainder as
dividend.

That works but some heuristic might be faster, perhaps assuming the division
won't have short result if eax starts less than ebx.

~
IntDivide$$:
Remainder$$:
Divide$$:mov Z.OpIs,bl
 Downcall NumDxBxjnz ArithLeftmov ecx,edxmov eax,ebx
 Upcall NumDxBxjnz ArithRightDown
 push CursorSi
; About to divide ecx:eax by edx:ebx, result to V.
 cmp eax,ebpje DivideNull
 cmp ebx,ebpje ZeroDivide
; Sign of answer to Z.SignM
 mov Z.SignM,clcmp Z.OpIs,$pRemainderje @Fxor Z.SignM,dl@@:
 sar ecx,1sar edx,1
 sub ecx,edx; ecx now result exponent undoubled. edx freed.
 mov esi,ebpmov edx,ebp
; esi**ecx now with partial result (0 to begin). eax:edx now 64 bit dividend.
 cmp Z.OpIs,$pDividejne RemIntDiv
@@:cmp eax,ebxjae @F
; Multiply achieves shift of one decimal place, 64 bit answer in edx:eax.
; Shift will be compensated by exponent adjustment.
 dec ecxmul Y.N10jnc @B
@@:; Now Dividend at least size of divisor.
; That was just a speedup to avoid producing initial zeros from the loop.
DivLoop:div ebx; Divide into edx:eax with result to eax and remainder in edx.
; ((esi+eax)*ebx+edx)*10**ecx is result of original divide
 add eax,esi; From an earlier cycle.
 cmp edx,ebpje DivExact; Done if remainder zero.
 cmp eax,Z.DivBreakjae @F; Done if enough digits known.
; Treat as (10*(latest eax)*ebx+10*edx)*10**(ecx-1) to get more digits.
; The 2-operand imul alters just its first operand (and flags).
 dec ecximul eax,10mov esi,eaxmov eax,edxmul Y.N10jmp DivLoop
@@:; When needed number of digits, round based on remainder.
 add edx,edxcmp edx,ebxjb @Finc eax@@:
DivExact:
; An insignificant trailing zero is one that would come after the decimal point.
@@:mov esi,eaxTestReg ecxjns @F
 mov edx,ebpdiv Y.N10test dx,dxjnz @Finc ecxjmp @B
; Put sign of result in.
@@:shr Z.SignM,1adc ecx,ecx
 mov eax,esipop CursorSijmp MagTest

ZeroDivide:mov ax,MkMajMin(42,3)jmp Raise

RemIntDiv:
; For % and // it is the integer part of the dividend that gets divided into.
; We have already set up so that divisor is integer.
; % and // must not make negative exponent.
; This case not speeded up for leading zeros.

if 0
 cmp ecx,ebpjge @F
endif
; We could divide by power of ten so that ecx became zero. Then put the residue
; aside to go with the final remainder. Do the divide into integer part.
; Or just bail out to ArithOp.   NYI
MayFloat:; For now
 pop CursorSi
 Up
 jmp ArithGeneral
if 0
@@:  ; NYI 26p11 test
endif

; Here with non-$pDivide, non-neg exponent of dividend (ecx), integer divisor.
IntDivLoop:div ebx
 add eax,esi; From an earlier cycle.
 jc MayFloatcmp eax,Z.Ceilingjae MayFloat
 cmp ecx,ebpje IntDiv; Done if last divide was of integer.
 dec ecximul eax,10mov esi,eaxmov eax,edxmul Y.N10jmp IntDivLoop
; eax is the // result. edx is remainder.
IntDiv:cmp Z.OpIs,$pRemainderje IntRem
; Put sign of result in.
@@:shr Z.SignM,1adc ecx,ecx
 Move Vpop CursorSiBackRet

IntRem:mov eax,edxjmp @B

ZeroInt:cmp Z.OpIs,$pRemainderje DivideNull
ArithZero:mov V.Mantissa,ebpmov V.ExpAnd,ebp
DivideNull:pop CursorSiBackRet

Power$$:call ToWholeEbxjnc ArithGeneral
 jmp Raise26p8

; Unary operators.
Negate$$:;  "-0" is not allowed to occur.
 call NumDxBxjc Raise41p3jnz NegGencmp ebx,ebpje @Fxor V.Sign,1@@:BackRet
; Use ArithGeneral of 0 - Subject
NegGen:UpMove V,V0mov V0.Mantissa,ebpmov V0.ExpAnd,ebpjmp ArithGeneral

Positive$$:
 call NumDxBxjc Raise41p3jnz @FBackRet
; Use ArithGeneral of Subject + 0
@@:Upmov V.Mantissa,ebpmov V.ExpAnd,ebpjmp ArithGeneral

Raise26p12:inc bp
Raise26p11:inc bpinc bpinc bp
Raise26p8:inc bp
Raise26p7:inc bp
Raise26p6:inc bp
Raise26p5:inc bp
Raise26p4:inc bp
Raise26p3:inc bp
Raise26p2:inc bp
Raise26p1:inc bp
 mov dl,26jmp Raise

Raise41p7:inc bp
Raise41p6:inc bp
Raise41p5:inc bp
Raise41p4:inc bp
Raise41p3:inc bp
Raise41p2:inc bp
Raise41p1:inc bp
 mov dl,41jmp Raise

Raise33p3:inc bp
Raise33p2:inc bp
Raise33p1:inc bp
 mov dl,33jmp Raise

Raise34p6:inc bp
Raise34p5:inc bp
; The two above were checked in a subroutine before saving CursorSi.
 PopJunk cx; Makes Raise push CursorSi in required place.
Raise34p4:inc bp
Raise34p3:inc bp
Raise34p2:inc bp
Raise34p1:inc bp
  mov dl,34jmp Raise

Raise40p11:mov al,11jmp Raise40
Raise40p32:mov al,32jmp Raise40
Raise40p33:mov al,33jmp Raise40
;------------------------------------------------------------------------------
; This the significant recovery point.
;------------------------------------------------------------------------------
comment~ Raising SYNTAX occurs all over the code, so it makes sense to transfer
as much of the work as possible to here, rather than the invoking site.

The caller need not unwind calls and pushes since stack is reset here.
Insert.Value is always stored, even though the message may not need it.
Insert.Desc is always stored, even though the message may not need it.

Error detection in the parser does not take much code - the syntax tables hold
the message numbers in 14 bits and one place in Cycle deals with them, see
IssueError.  Error detection for the parameters to a builtin is also handled at
one place, see BifTypes.  The remaining errors can be individually handled by
loading AX with the message number and branching to Raise.  The code is labelled
RaiseMMpNN usually, with MM.NN the message number.

However, some groups of messages (Majors 29 33 34 41 42 particularly) use a
"trick" with BP to shorten the code.

Inserts are established in various ways.  The non-line-number <value>s, the
<description>, and the error number (which may get further adjustment) arrive
at Raise in registers.
<argnumber> is run time.
<optionslist> is run time.
<sourceline()> is run time.

The <token> is set by compiling and only happens in compile messages.
<char> is compile only, given ASCII char set.
<position> is compile only.
<keywords> is compile only.
<hex-encoding> is usually compile time but we also use it for I/O error so
the value at Raise should be preserved over any Synch necessary.
<name> is both compile and run. Preserve it over Synch.
<bif> is done by compile, so needs a Synch if in runtime message.
<operator> is done by compile, so needs a Synch if in runtime message.

~
;------------------------------------------------------------------------------
; Raise stage 1, collect the message number and some insert info.
; It is assumed that we cannot be in the middle of synchronizing because if
; the source parsed OK originally it will do for Synch.
; Similarly we are not in a clause-by-clause compilation.
; We can be in the original compilation, INTERPRET compilation, or the
; execution of original, INTERPRET, clause-by-clause Pcode.
;------------------------------------------------------------------------------
Raise49:
if Debug
 int 3pop ax; Caller.
endif
 mov ax,MkMajMin(49,0)jmp Raise

comment~ The syntax conditions raised from the Builtins that were Bcoded have
a variety of arguments.

40.4  ArgNum
40.17 Value
40.18
40.19 Value Value
40.29 Value
40.35 Value
40.38 ArgNum Value
40.39 Value
40.41 ArgNum Value
40.42 Value

~

CONFIG_RAISE40$$:
 mov si,Z.XCycleResetSpmove Wptr[si+bp-4],Z.ResumeP
 call ResumeP$
 mov al,Bptr V.Mantissa; The minor code.
 Downcmp al,4je @Fcmp al,38je @Fcmp al,41jne NoArgNum
@@:mov dl,Bptr V.Mantissamov Z.Insert.ArgNum,dlDown
NoArgNum:cmp al,19jne @FDown@@:
; 40.18 won't care about inserts.

Raise40:mov ah,40
Raise:
; Non-zero bp is just a space-saving trick for passing value for al.
; (Requires dl for ah also.)
 TestReg bpjz @Fxax bpxor bp,bpmov ah,dl@@:
; Some registers will be relevant only for certain messages. Store anyway.
 mov Z.Insert.Desc,dlmov Z.Insert.Value,StackDi
 push CursorSi; Only relevant to retrieve it if operator did not push it before.
 push CursorSi
if 0
 int 3
endif
; All the 41.xx have to become 41.7 if exponent range is the reason.
 cmp ah,41jne Not41
 Qry Z.Cancel,ExpRangejz @Fmov al,7@@:
; The message number is now in AX
Not41:z Z.Cancel; Cancel any flags that might be pending.

; The <linenumber> insert takes its value from Z.InsLine.
; A parser state has a field, ClauseWas, to hold relevant previous line
; numbers. Because we came here on a jump, sp will address the current state.
; The case of major code 14, (incomplete DO...) the number in the pre-message
; has to change. Set si for source of number, di where to put it.
 mov ParseSi,spmov di,Zshape.ClauseLine
 cmp ah,14jne @Fmov di,Zshape.InsLinejmp Is14@@:
; The case of major code 7, the relevant SELECT has to be found on the stack.
 cmp ah,7jne Not7cmp al,1je @F
Is14:add ParseSi,$StrideS
@@:move Wptr[di+bp],S.ClauseWas,dx
Not7:mov Z.Insert.MajMin,ax

;------------------------------------------------------------------------------
; Raise stage 2, note where the SYNTAX error occurred, and position the source
; to match if necessary.
;------------------------------------------------------------------------------
; There can be message before we really get started. eg couldn't find source
; of the very first file.
 cmp Z.Code,ZeroBpje InSynch
; If we have never started executing this source file, the line number etc will
; be current.  SYNTAX trapping cannot have been turned on in this file.
 cmp Hg.Original,ZeroBpje InSynch
; There has been some execution of this file, so can find the execution point
; relevant to the Raise.  Also there is a place for .MN
; Could not store .MN if Z.ProgScope not yet made.
; Put ax into .MN, still in Major+Minor format. (May not get used.)
 mov ProgEs,Z.ProgScopemov Ve.Dtype[$?MN],$MsgNummov Ve.MantLow[$?MN],ax
; At this point we are in execution, although could be parsing part of
; INTERPRET. So we will have called Operator and the Raise is from some
; operation.
; Mar 2000 method of recover CursorSi is to ensure it was first thing saved
; by execution of the operation.
; Link to the operator follows reset place, want below that.
 mov si,Z.XCycleResetSpmov CursorSi,Wptr[si+bp-4]
; At this point CursorSi is correct, either for a message or as SIGL.
 mov Z.Synch,CursorSi;
; NYI - loop protection for msg 5 or 49.
; It may be that SYNTAX is being trapped and the message will never be shown
; but we make it anyway for CONDITION('D')
; If error was detected while compiling, the info for inserts will be available.
; So in the compile-of-INTERPRET-subject case we could record that before
; doing the synch required to get the line number of the INTERPRET clause.
; However, in the not-compiling case we have to synch on both the source file
; and the subject so might as well always do that.
;
; This re-compilation up to the Z.Synch point is very similar to the
; original compilation.
; The Synch won't necessarily happen with all the Zone fields the same as now.
; We copy some that might get harmed, don't copy ones Synch is to set.
; ?? InsBlock mechanism over-engineered?
; Execution messages don't use <token> so TokPos is in the copied block to
; retain it for the INTERPRET case.
 mov si,Zshape.Insertmov di,Zshape.Insertscall CopyInsert
 add Z.Stack,2*$StrideV; Protect what may be needed for Z.Insert.Value.
 mov Z.Cursor,$StrideHz Z.Scanp
; LabelsBad tells us whether it was INTERPRET that failed, although this
; Synch is against the original, not the INTERPRET subject.
 btr Z.Program,LabelsBadjnc NotINT
if Debug
 mov ds,Z.Consts
 mov ax,Hd.Avail
endif
 call Compiling
if Debug
 push ds
 mov ds,Z.Consts
 mov ax,Hd.Avail
 pop ds
endif
; We also have to restore the buffer, in the case where a message from
; INTERPRET uses Insert.TokPos.
 mov al,$SerialInterpretcall Serialize
 jmp @F
NotINT:
if Debug
 mov ds,Z.Consts
 mov ax,Hd.Avail
endif
 call Compiling
if Debug
 push ds
 mov ds,Z.Consts
 mov ax,Hd.Avail
 pop ds
endif
@@:mov si,Zshape.Insertsmov di,Zshape.Insertcall CopyInsert
InSynch:
 z Z.Scanp
 Off Z.Program,LabelsBad
;------------------------------------------------------------------------------
; Raise stage 3, convert all the info to a text message.
; Save the message if not now finishing.
;------------------------------------------------------------------------------
; If the condition is handled, we go back to execution as if there had
; been SIGNAL rather than SYNTAX.
;
; Too risky to allow handling in some cases.
 mov ax,Z.Insert.MajMin
 cmp ah,5je GetOutcmp ah,49je GetOut
; Assert Syntax is zero position amongst the conditions. Enabling < 8
 call HeritageDibtr L.Condition,Enablingjc OnSyntax
 pop di
; Exit with message and traceback.
GetOut:
 call MakeMsg; Result Z.MsgBegin to Z.MsgSoFar(and di).
 call ShowMsg
; TraceBack.        NYI
; Return code is error number. Only room for Major code.
 mov al,Z.Insert.Majorjmp Exit

CopyInsert:mov cx,sizeof InsBlock
 push esmv ds,ssmv es,ssrep movsbpop esret

OnSyntax:
;$8.4.1
 PopJunk ax
; BX tells where to resume interpretation.
 mov L.ConditionExtra.Dtype,$NullString
 mov bx,L.TrapName
comment~ We will have to allocate space to make the message an ordinary value
now, because we don't want to leave it in a special place while doing a
compaction.  We could build the message in that space but that is not clearly
best - it would prevent DS being kept addressing the compressed text.
~
 mov cx,$MaxPreInsert+5*$Limit_Insertcall AllocateCx_EsAx
 mov L.ConditionDescription.Dtype,$AwayStringmov L.ConditionDescription.Sg,es
 mov L.ConditionDescription.Pt,axmov L.ConditionDescription.Len,cx
 push LevelDi
 call MakeMsg; Result Z.MsgBegin to Z.MsgSoFar(and di).
 pop LevelDi
; Move the message to variable allocated earlier.
 mov cx,Z.MsgSoFarmov si,Z.MsgBeginsub cx,si
 mov L.ConditionDescription.Len,cx
 les di,L.ConditionDescription.Fr
 rep movsb [di],ss:[si]
 mov CursorSi,Z.Synch
 jmp OnSyntaxX
SignalV$$:
 Error49Bp

Signal$$:mov bx,gs:[CursorSi]
OnSyntaxX:
 Off Z.Cancel,TokIsValue
 mov sp,Z.XCycleResetSp
; bx is the label sought.
; CursorSi is where the jump was from.
comment~ In the case of SIGNAL we might reasonably finalize .SIGL at once
but CALL would be too slow if we did that. It seems we need lazy evaluation
in converting Pcode offset to line number for .SIGL
It is a bit pesky because if we do the conversion as the number is loaded to
the stack we either need an extra test in loading from ProgScope or we need
an extra operator just for the job. If conversion is left to operand check
time it is an extra test everytime there. Current plan is to test on load of
variables and with $pSysVar for loads from "constants".
Variables case , eg SIGL, can test on load.
~
 mov ProgEs,Z.ProgScope
 mov Ve.Dtype[$?SIGL],$Siglmov Ve.MantLow[$?SIGL],CursorSi
; There are both .SIGL and SIGL.
 mov Vf.Dtype[$?SIGLx],$Siglmov Vf.MantLow[$?SIGLx],CursorSi
; Lose DOs, INTERPRETs and temps.
 mov LevelDi,Z.Level
 mov Z.Stack,StackDi
 mov Z.CurrentDO,StackDi
; Test for trace-only or absent label.
 mov ax,MkMajMin(16,2)cmp Bptr Vbxe.LabelType,0jne Raise16
 mov cx,Vbxe.LabelValue
 JcxzQ @Fmov CursorSi,cxjmp StartExecutionY@@:
; Label never appeared with colon.
 dec ax
Raise16: mov ds,Z.Consts
 mov bx,Vbx.Heremov Z.Insert.Named,bx
 jmp Raise

CallOn$$:mov dl,mask Instruction + mask Enablingjmp @F
SignalOn$$:mov dl,mask Enabling
@@:call HeritageDi
; The condition is in the next byte.
; Syntax,LostDigits,NoValue,NotReady,Error,Failure,Halt
 mov bl,Bptr gs:[CursorSi]inc CursorSi
; Target label follows.
 lodsw gs:[CursorSi]add LevelDi,bx
 and Bptr(L.Condition),not(mask Enabling+mask Instruction)
 or Bptr(L.Condition),dladd LevelDi,bxmov L.TrapName,axpop StackDiBackRet

SignalOff$$:
; MASM error ...............................
 movzx bx,Bptr gs:[CursorSi]inc CursorSi
 push StackDimov LevelDi,Z.Leveladd LevelDi,bx
 and Bptr L.Condition,not(mask Enabling)
 pop StackDiBackRet

Raise$$:
; The errors from number of args (statically detected) on a bif will be 40.n
; Other under this code is SELECT out of choices. 7.3
; ?? What about line number on that?
; Also PROCEDURE misplaced. 17.1
 mov bl,Bptr gs:[CursorSi]inc CursorSimov ax,Raise$[bx]jmp Raise
if Solid
Raise$:
 dw MkMajMin(7,3)
 dw MkMajMin(17,1)
 dw MkMajMin(40,3)
 dw MkMajMin(40,4)
 dw MkMajMin(40,5)
endif

comment~ There could have been a Pcode to say "Make control block for iterative
DO" but it is more efficient to let the first expression of the DO get loaded
before making the block.  It follows that the DO control block will overlay the
result of that expression.

~
Jump$$:mov CursorSi,Wptr gs:[CursorSi]BackRet

Raise34:cmp Bptr(gs:[CursorSi-3]),$pThenjne Raise34p2jmp Raise34p1

When$$:Then$$:call ToWholeEbxjc Raise34lodsw gs:[CursorSi]
 dec ebxjz @Finc ebxjnz Raise34mov CursorSi,ax@@:DownBackRet

comment~ In execution the stem will begin like an ordinary variable and contain
the default value. This means taking
two slots in the names array for each stem.  In the second slot we keep
lookaside (probe) and a pointer to the compound variable set.

~
AssignConst$$:; This is assign without going via stack.
; Only 15% faster than Assign$$.  I wonder if the order affects pipelines.
; Might have been alignment affected.
 mov bx,gs:[CursorSi]Move ,Vbxe
; Swop to Assign$$ when target exposed.
 mov bx,gs:[CursorSi+2]add CursorSi,4cmp Vbxf.Dtype,$Exposedje @F
 Move VbxfBackRet

@@:UpMove Vjmp AssignExposed

; Unstore follows Assign if the assigned value is to be reloaded.
Unstore$$:UpBackRet

Assign$$:; The target will be the only argument.
; ControlVar$$ relies on BX, EAX, ECX at return.
; If the target is changing from uninitialized in this procedure to initialized,
; that has to be recorded so that it can be backed out when the procedure
; returns, making the array of variable names fit for reuse. NYI
 mov bx,gs:[CursorSi]add CursorSi,2; Add2 is slower.
AsgnToFsBx:cmp Vbxf.Dtype,$Exposedje AssignExposed
 Move Vbxf,VDownret

AssignExposed:; A bit slower because of FS temporary shift.
 call ExposedFs
AssignRet:Move Vbxf,Vmov fs,Z.VarScopeDownret

ExposedFs:; Sets FS to the non-exposed level for variable BX.
; Assert - Dtype is $Exposed in current FS:BX
; When setting something to $Exposed we should not follow the expose chain.
 Qry Z.Cancel,ForExposejz @Fret
; Scan for containing procedure.
@@:mov fs,Hf.UpPoolcmp Vbxf.Dtype,$Exposedje @Bret

comment~  There is a choice about implementing execution of DROP and EXPOSE;
whether to handle the dynamic cases like DROP (abc) as INTERPRET "DROP" abc.
The alternative is scan the abc and invoke some pieces of the compiler at a
primitive level. There has to be some prescan of abc even if INTERPRET is used,
eg to prevent comments being accepted.

There is a slight complication that INTERPRET "PROCEDURE EXPOSE" abc would fail
from not-following-label but that is fixable.

The decision extends to VALUE(abc,99) as INTERPRET abc'='99 and to the variable
pool interface.

Aug 99 plan is to avoid the INTERPRET route because of TRACE concerns.

At first glance it seems that for exposed compounds,
eg PROCEDURE EXPOSE ABC.1DEF it would be most efficient to restrict the
necessary lookups to just the time of the EXPOSE, subsequently retaining
in the local pool the results.  Then at reference time there would be a
direct link to the exposed item.  The trouble with this approach is that
the stem may also be exposed and assigned to, eg ABC.=99.  Such an
assignment would usually be done efficiently by throwing away the tree
of elements ABC. has and relying on the default value for a stem mechanism
to provide values on subsequent references.  But that throwing away is
flawed if what is thrown includes targets of expose references. While this
might be solved by using different mechansims for ABC.=99 according to
whether or not ABC. was in the local pool, it may be more reasonable to
do multiple lookups at reference.

~
DropList$$:push CursorSi
; We want to parse the value into symbols but using compiler would
; allow comments etc.
 call ToDsSiCxmov bx,Attributes
 Upcall VasDsSiCx; A copy to alter.
; Skip blanks
DropLoopX:JcxzQ DropListRet
DropLoop:lodsbXlatBDLSjnz @FLoopQ DropLoop
DropListRet:sub StackDi,2*$StrideVpop CursorSiBackRet

; Begin of potential symbol found. Check it is a name.
@@:dec simov dx,sicall SymbolLookTestReg bxjnz Raise20p1
 push cxpush si
; Set up V to be just the symbol found.
 mov V.Pt,dxsub si,dxmov V.Len,si
; Drop by interpret.
 mov dx,offset B4DROPcall LinkBcodemov Z.Stack,StackDi
 pop sipop cxjmp DropLoopX
Raise20p1:; This msg can happen as runtime or compile time. The insert is
; <token>, which is fine for compile time. For runtime we need a flag to
; treat the insert differently.
  mov fs,Z.VarScope
  mov Z.Stack,StackDi
  pop CursorSiOn Z.Cancel,TokIsValuemov ax,MkMajMin(20,1)jmp Raise
Expose$$:lodsw gs:[CursorSi]xax bx
; Tail parts on the stack if compound name.
 mov ax,StackDisub ax,Z.CurrentDOjnz @F
 mov Vbxf.Dtype,$ExposedBackRet
@@:push CursorSiOn Z.Cancel,ForExpose
 sub ax,$StrideVcall DotsFsBxDsSiDown
 Off Z.Cancel,ForExpose
 mov Vsid.Dtype,$Exposedmov fs,Z.VarScopez bxpop CursorSiBackRet

ExposeList$$:; EXPOSE (A) first does EXPOSE A.
 call Expose$$
 push CursorSi
 TestReg bxjnz @FError49Bp@@:
 CodeModeR
 call FetchBx
 UnCodeMode
 call ToDsSiCxmov bx,Attributes
 Upcall VasDsSiCx; A copy to alter.
; Skip blanks
ExposeLoopX:JcxzQ ExposeListRet
ExposeLoop:lodsbXlatBDLSjnz @FLoopQ ExposeLoop
ExposeListRet:sub StackDi,2*$StrideVpop CursorSiBackRet
; Begin of potential symbol found.
@@:dec simov dx,sicall SymbolLookTestReg bxjnz Raise20p1
 push cxpush si
; Set up V to be just the symbol found.
 mov V.Pt,dxsub si,dxmov V.Len,si
 mov dx,offset B4EXPOSEcall LinkBcodemov Z.Stack,StackDi
 pop sipop cxjmp ExposeLoopX
Dots$$:; Fetch from a compound. The compound is the only argument.
; The values for the tail parts are parameters.
 movzx ax,Bptr gs:[CursorSi]inc CursorSi
; AX now 0 = One part tail, $StrideV = two part tail,...
 mov StemBx,gs:[CursorSi]add CursorSi,2push CursorSi
 call DotsFsBxDsSi; Sets FS:BX the lower of pair, DS:SI the item.
 cmp Vsid.Dtype,$Omittedje DotsNew
PostDotsNew:test Vsid.Dtype,$Testjg TailedDropped
 Move V,Vsid
DotsReturn:mov fs,Z.VarScopepop CursorSiBackRet

DotsNew:; New item gets it's value from the stem default.
; Assert - default known not to be exposed.
  Move Vsid,Vbxfjmp PostDotsNew

TailedDropped:
if Debug
 cmp Vsid.Dtype,$Droppedje @FError49Bp@@:
endif
; Have to construct STEM.tail as value.
 call ValueIsName
; Recover the tail - it is the key of the compound.
 Up
 mov V.Sg,dsmov ax,J.KeyLenmov V.Len,ax
 lea ax,J.Keymov V.Pt,ax
 call Away
 call Abut$$
 jmp DotsReturn

Away:; Mark stack as an away string if not optimizable.
 push cxmov cx,V.Lencmp cx,7jna @Fmov V.Dtype,$AwayStringpop cxret
@@:push dspush silds si,V.FrMv V,Vsid
 add cl,$NullStringmov V.Dtype,cl
 pop sipop dspop cxret

AssignStem$$:; eg ABC.=99
; If the whole stem is exposed we must change pool until it isn't.
 mov bx,gs:[CursorSi]add CursorSi,2
 cmp Vbxf.Dtype,$Exposedjne @Fcall ExposedFs@@:
; Look at the stem to see if anything (ABC.XXX as opposed to ABC.) is exposed.
; The stem may never have been used.
 cmp Vbxf2.Dtype,$Droppedje AssignRet; to just set default value.
 push CursorSi
 mov ds,Vbxf2.Sgmov TailSi,$StrideH
 cmp Vsid.Dtype,$Exposed
 je SomeExposed
; Empty the stem segment.
 mov Hd.Avail,$StrideHz Hd.Probe
 pop CursorSi
 jmp AssignRet; To set ABC.

comment~ Bit of design choice here. We have to assign the stack value to
each of the exposed compounds. For the non-exposed compounds already in
the stem's segment the efficient thing is to discard them.  The easier
thing is to assign the stack value to them also. (Avoids need to rebuild
lookup tree of the retained items.)
~
SomeExposed:; DS:SI item to be given Stack value.
AssignLoop:; Simple when it is not exposed.
 cmp Vsid.Dtype,$Exposedje AssignUp
AssignUpRet:Move Vsid,V
 add TailSi,J.KeyLenadd TailSi,$StrideJ
 cmp TailSi,Hd.Availjb AssignLoop
 pop CursorSijmp AssignRet
AssignUp:mov Z.StackLo,StackDi; So that DotsRet can be used.
 push AssignUpRetjmp DotsExposed
Drop$$:; Done as assignment of the value $Dropped
 cmp StackDi,Z.CurrentDO
 UpCaremov V.Dtype,$Droppedjz Assign$$
; Compound assignment.
; Components of the tail are on the stack.
AssignDots$$:lodsw gs:[CursorSi]mov StemBx,axpush CursorSi
; Improve performance - set StackLo NYI
 mov ax,StackDisub ax,Z.CurrentDOsub ax,2*$StrideV; At least value & a tail
 call DotsFsBxDsSi
 Down; DotsFsBxDsSi allowed for value pickup by Dots$$.
 Move Vsid,VDownmov fs,Z.VarScopepop CursorSiBackRet

comment~ INTERPRET works by compiling Pcode on to the end of the Pcode segment,
running it with XCycle, then moving the pointer back to discard it.
Three uses are distinct:
- Initially compiling the $Reserved string to set up system variables and
  constants.
- An INTERPRET in the programmer's program. (Which can be recursive)
- An INTERPRET in Bcode, eg implementing VALUE('ABC',99).

In the case of the programmer's INTERPRET, we need a flags to disable labels.

There are three steps to an interpret: A compile step that makes new Pcode, an
execution step that runs that Pcode, and recovery step that throws away the
temporary Pcode. The compile step can transfer to Raise when there is a
SYNTAX error and the other steps are not needed. A successful compile step
makes a $pInterpEnd at the end of the Pcode and execution of that causes the
recovery step. A SIGNAL during INTERPRET will have recovery as a by-product.
Looks like RETURN is a special problem - we need recovery when interpret is
finished that way. NYI

Everything pending about an INTERPRET in the execution step is held in a block
on the stack like a DO block.  That ensures recursion, external call, etc are
OK.

Execution resumes by the ret here, at D.PcodePos the newly
compiled Pcode. When execution reaches the InterpEnd the temporary Pcode is
discarded and execution resumes after the INTERPRET (CursorSi = D.Leaving)

~

Interpret$$:
 On Z.Program,LabelsBad; Tell Parser whats up.
Interpret1:
 push CursorSi
 cmp Z.ResumeP,ZeroBpje @F
 On Z.Cancel,BcodeInterpret; Off at InterpEnd
 mov gs,Z.Code
@@:
; INTERPRET can nest so we need a block on the stack to hold each generation.
; It is very like a DO block, in that it goes away when there is a SIGNAL.
; And provides base for counting tails on assign.
; Build DO-like block over where the parameter was.
; Normally DO blocks are adjacent because DO inside DO occurs with nothing
; on the stack. BcodeInterpret is different - new Bcoded routine without
; new Z.Level - so complicates Z.CurrentDO maintenance.
 add StackDi,$StrideD-$StrideVmov ax,Z.CurrentDO
 mov Z.Stack,StackDicall StackSafemov D.UpDO,ax
 mov Z.CurrentDO,StackDi
 On D.Rec,IsInterp
 pop CursorSipush CursorSimov D.Leaving,CursorSi
; CursorSi not needed but left stacked for error messages.
 move D.PcodePos,Hg.Avail; Where code will start.
 mov Z.Cursor,ax
 mov al,$SerialInterpretcall Serialize
 z Z.Synch
 call Compiling
 pop si
 mov al,$SerialNonecall Serialize
 cmp Hg.Original,ZeroBpjnz @F
; No execution when $Reserved.
 sub StackDi,$StrideD-$StrideVmov Z.CurrentDO,StackDimov Z.Stack,StackDi
 ret
; If it failed to parse, that is handled at label Raise.
@@:mov CursorSi,D.PcodePos; Resume by executing the new code.
 jmp StartExecutionY
;MASM..............................
InterpEnd$$:; Code made from an INTERPRET statement has completed.
 move Hg.Avail,D.PcodePos; Reclaim code space.
 btr Z.Cancel,BcodeInterpretjnc Leave$$
; Like Leave$$ but the INTERPRET was in Bcode.
 mov CursorSi,D.Leaving
 move Z.CurrentDO,D.UpDO
 sub StackDi,$StrideD
 mov Z.Stack,StackDi
 mv gs,csPopJunk axret


;------------------------------------------------------------------------------
; The remaining verbs.
;------------------------------------------------------------------------------
Options$$:
; None yet.
 DownBackRet

Push$$:
Queue$$:push CursorSi
; Length of aggregate is first word of Z.Serial.
; Items have their length at both ends of the item.
 mov al,$SerialQuecall Serialize
; Establish value to be pushed.
 call ToDsSiCxpush StackDi
; Check room.
 mov ax,Wptr Z.Serial; Previous aggregate length.
 mov dl,$DescQueue
 add ax,cxcmp ax,sizeof Zshape.Serial-6ja Raise5p1
 mv es,ss
 mov ax,cxadd ax,4; For two lengths
; If Queue, existing aggregate will have to move right.
 cmp bl,$pQueuejne @F
 push sipush cx
 mov si,Wptr Z.Serialmov cx,silea si,Zshape.Serial[si+1]; Rightmost byte
 mov di,siadd di,axstdrep movsb [di],ss:[si]cldpop cxpop si
@@:mov dx,Wptr Z.Serial; Previous aggregate length.
 add Wptr Z.Serial,ax; New aggregate length.
; Copy argument to Serial.
 mov di,offset Zshape.Serial+2
 cmp bl,$pQueueje @Fadd di,dx@@:
 stosw; Place first copy of length.
 rep movsbstosw; data then second.
 pop CursorDiDown
 mov ProgEs,Z.ProgScope
 pop CursorSiBackRet

; Some simple verbs.
Say$$:
 push CursorSicall ToDsSiCxmov dx,simov bx,Z.Stdout
 mov ah,$DosWriteint 21h; Takes ds:dx:cx to file bx
 mv ds,csmov dx,Yshape.CrLfmov cx,2
 mov ah,$DosWriteint 21h
; Say in Bcode just for debug.
 cmp Z.ResumeP,ZeroBpjne @F
 Down
@@:pop CursorSiBackRet

comment~ The most liberal character form for numbers is given in section $7 of
the standard.  The normalized character form, as produced for arithmetic
outputs, removes leading zeros etc.  and is dependent on the NUMERIC settings.

For DIGITS less than 10, and particularly the default of 9, a binary 8 bytes is
sufficient to encode all the possible values. Even when DIGITS is more than 9,
some possible values will fit in the binary range.

Conversion is required between the liberal format and the binary format or
(if the binary won't hold it) the normalized character form.  Conversion in
the other direction produces the normalized character form or it's
generalization by the FORMAT bif.

Even in binary form, numbers are not uniquely represented, for example an
exponent of 0h and mantissa of 0Ah is the same value as exponent of 1h and
mantissa of 1h.  The binary form always has zero as all binary zeros, and
sometimes it is forced to exponent=0 for the "whole number" format.  (Note that
0Ah with exponent -1 is not the same as 1h with zero exponent since one converts
to "1.0" and the other to "1".)

~
;------------------------------------------------------------------------------
; Conversion to Number.
;------------------------------------------------------------------------------
; NumDxBx makes the stack variable a number, setting carry iff it
; cannot do that at 9 digits. ebx:edx left as copy of number stacked.
; si and di are preserved.  ax and cx are not.
; Entered at label NumDxBx.

; Mantissa ended on non-blank. Check it is dot or E or e.
; For this pass, dot is like a digit.
FnMantx:jpe FnChartest al,$Eejnz FnMantz
; Pity attributes of Dot not different from some other letters.
 inc dicmp Bptr[si-1],'.'je FnPostDot
; FnChar is place where syntax has proved to be non-number.
FnChar:pop ecxpop eaxpop StackDitest V.Dtype,$TeststcRetSi

; Blank or 'E' ends mantissa. Set to rescan it.
FnMantz:dec sijmp FnMant

FnPostSign:cmp ah,'.'je FnNoSign
FnChSt:jmp FnChar

FnExpd:dec simov Z.ExpPosZi,sijmp FnB

; Build up the exponent.
FnExp:inc sidec cxjz FnChStlodsbxlat cs:Bptr[bx]
 mov Z.SignE,aland al,$Groupcmp al,$PlusMinusjne @F
 dec cx
 JcxzQ FnChSt
 inc si
@@:dec simov Z.ExpPos,si
; Scan exponent digits.
@@:lodsbXlatBDLSjz FnExpdjs FnChStLoopQ @B
 mov Z.ExpPosZi,sijmp FnDone

Qret:mov ebx,V.Mantissa
Qretx:mov edx,V.ExpAndret; Test has cleared flags.

; In this version (Aug 99) we are not using the $AwayNum type, using char
; types instead.
; On return the flags register reflects the Dtype of the result, with also
; Carry set if not number syntax. (ie Carry implies compare non-numeric.)

NumDxBx:
 test V.Dtype,$Testjz Qret
; May 2000 Still not done AwayNum so will have to check numberness each use.
WasChar:Off Z.Cancel,ExpRange
 push CursorSipush StackDipush eaxpush ecx
 call ToDsSiCx
 JcxzQ FnChSt; Empty string is not a number.
 mov bx,Attributes; For XLAT
; There just are not enough registers to make it sensible to do everything in
; one pass.  Better to have a first pass that finds the digits.
; si is for lods, cx counts unconsumed characters.
; When jumping out of loops si/cx are out of step. dec si rescans, dec cx keeps.
; First pass details are recorded in Z. fields, and in di for decimal point.
 z Z.ExpPosZi
; Skip leading blanks. String all blanks is not a number.
@@:lodsbXlatBDLSjnz @FLoopQ @Bjmp FnChSt@@:
; Note sign. Future test will be against $AttribMinus
 mov Z.SignM,aland al,$Groupcmp al,$PlusMinusjne FnNoSigndec cx
 JcxzQ FnChSt
; Skip blanks after sign.
@@:lodsbmov ah,alXlatBDLSjnz @FLoopQ @B
FnChSt2:jmp FnChSt@@:js FnPostSign
FnNoSign:dec si; Here with a digit upcoming, usually.
 mov Z.MantPos,siz di; To count decimal points.
@@:lodsbXlatBDLSjz FnMantzjs FnMantx
FnPostDot:LoopQ @B
; Fall thru when digits go to the end.
FnMant:; Back to here from FnMantx when 'E' upcoming, or blank.
; At most one decimal point.
 cmp di,1ja FnChSt2mov Z.MantPosZi,si
; Mantissa better have some digits in it.  .E+99 is wrong.
 sub si,dicmp si,Z.MantPosje FnChSt2mov si,Z.MantPosZi
; Similarly for exponent.
 JcxzQ FnDonetest al,$Eejnz FnExp
; Trailing blanks OK
FnB:lodsbXlatBDLSjnz FnChSt2LoopQ FnB
FnDone:
; Here are two checks whether the number will go in our binary format.
; Mantissa to ebx, exponent to edx.
 mov edx,ebpmov cx,Z.ExpPosZiJcxzQ FnNoExpmov si,Z.ExpPossub cx,si
 mov eax,ebp
@@:lodsbsub al,'0'
 imul edx,10js FnBigExpadd edx,eax
 cmp edx,Y.N1e9jae FnBigExpLoopQ @B
 cmp Z.SignE,$AttribMinusjne @Fneg edx@@:
FnNoExp:
; That has got the exponent, as written, into edx, and validated.
; We shall return saying this has number syntax.
; If the syntax was non-number we would have returned (with Carry) and
; not reached here. So anything awkward from here on we can say "long number",
; (even if it doesn't need a lot of digits) and it will be dealt with by
; ArithGeneral rather than the code for binary values.
; Now for mantissa to ebx.
 z edimov si,Z.MantPosmov cx,Z.MantPosZisub cx,si
 mov ebx,ebpmov eax,ebp
FnMloop:lodsbcmp al,'.'jne @Finc edijmp FnSkip@@:
; Large mantissa best done by ArithGeneral.
 sub al,'0'imul ebx,10jc FnLongadd ebx,eaxjc FnLongsub edx,edi
 cmp ebx,Z.Ceilingjnb FnLong
if 0
; If this is compile time we can pass the problem to run time by leaving
; the string in chars.
 cmp Z.Scanp,ZeroBpjnz FnLong
; There is unresolved language here.  For now:
 cmp cx,1je FnSkip
 call HeritageDicmp L.Digits,9pop StackDija FnLong
 cmp Bptr[si],'.'jne @Finc ediinc sidec cx@@:JcxzQ FnSkip
; Rounding
 cmp Bptr[si],'4'jbe PostRoundinc ebx
 cmp ebx,Y.N1e9jne PostRoundinc edxmov ebx,Y.N1e8
PostRound:
; We don't have the value yet since maybe more digits before dot.
FnLost:lodsbcmp al,'.'jne @Finc ediinc si@@:inc edxcmp al,'0'je @F
; Raise LostDigits?
 call HeritageDicmp L.LostDigits,0pop StackDijz @F
 Error49Bp
@@:sub edx,ediLoopQ FnLost
 inc cx
endif
FnSkip:LoopQ FnMloop
 cmp ebx,ebpjne @Fmov edx,ebp@@:
; !! check edx
; Exponent is held doubled, with sign of Mantissa added.
 add edx,edxcmp Z.SignM,$AttribMinusjne @Finc edx@@:
 cmp ebx,ebpjne @Fmov edx,ebp@@:
; The variable on the stack is altered when binary can fit.
 pop ecxpop eaxpop StackDi
 mov V.Mantissa,ebxmov V.ExpAnd,edx
 test V.Dtype,$TestRetSi
FnLong:
 pop ecxpop eaxpop StackDi
; Got to add zero anyway.
 mov StackSi,StackDipush StackDipush Z.Stackmov StackDi,Z.Stack
 UpMove V,Vsi,ebxcall Zero$$Down
 mov dl,$pAddcall ArithDl
 mov StackSi,StackDipop Z.Stackpop StackDi
 Move V,Vsi,ebx
 mov ebx,V.Mantissamov edx,V.ExpAnd
 test V.Dtype,$TestRetSi

; If it looks like a number, has exponent in range, but mantissa won't fit
; nine digits, then it is a long number.
; But long binary numbers not implemented yet.
if 0
FnLong:pop ecxpop eaxpop StackDimov V.Dtype,$AwayNumberRetSi
endif

FnBigExp:On Z.Cancel,ExpRangejmp FnChSt

ToWholeEbx:; Result to ebx and V.Mantissa. eax ecx edx used.
; Used from arithmetic and DataType to convert to number. (Or set Carry)
 call NumDxBxjc TwFail
 jz TwBinary
; Number in char form. Try to bring it to binary.
; Got to add zero anyway.   cf FnLong
 push si
 mov StackSi,StackDipush StackDimov StackDi,Z.Stack
 UpMove V,Vsi,ebxcall NumDxBx
 mov StackSi,StackDipop StackDi
 Move V,Vsi
 pop si
 Test V.Dtype,$Testjnz TwFailx; Unsound for 'W' test. NYI
TwBinary: mov ecx,V.ExpAndsar ecx,1jz TwOKmov eax,V.Mantissajs TwNegExp
if Debug
 cmp eax,ebpjne @Fint 3jmp TwOK@@:
endif
; Make the positive exponent zero by multiplying.
@@:mul Y.N10jc TwFailcmp eax,Z.Ceilingjae TwFailxdec ecxjnz @B
TwOKzero:and V.ExpAnd,1mov V.Mantissa,eax
TwOK:mov ebx,V.Mantissaclcret
; We might be able to avoid a negative exponent by dividing Mantissa by 10.
TwNegExp:mov edx,ebpdiv Y.N10cmp dl,0jnz TwFailx
 inc ecxjnz TwNegExpjmp TwOKzero
TwFailx:stc
TwFail:ret
;------------------------------------------------------------------------------
; ToDsSiCx sets registers to reflect the top stack item.
;------------------------------------------------------------------------------
; ToDsSiCx makes the stack variable a string and sets ds:si:cx to reflect it.
; eax,ebx,edx,edi preserved.
; high of ecx not preserved.  es not preserved.
ToDsSiCx:mov cl,V.Dtypetest cl,$Testjz ToStringjpe @F
; Here when it already is short string.
; mov ds,Z.Zone is faster than mv ds,ss
 and cx,7Assert Vshape.String eq 0mov ds,Z.Zonemov si,StackDiret
@@:

if Debug
cmp cl,$AwayStringjne @F
endif

; Here for already a long string.
 lds si,V.Frmov cx,V.Lenret

if Debug
@@:Error49Bp
endif

ToString:; Converting to character string.
; We don't know what the numerics settings were when the arith value was made
; so we have to have arranged that it is OK to assume SCIENTIFIC 9 digits.
 push eaxpush ebxpush edxmov ecx,ebp
; Special case single digits. That will include Booleans.
; This case requires exponent zero. The "sar" removes mantissa sign.
AfterRound:
 mov eax,V.Mantissamov ebx,V.ExpAndsar ebx,1jnz TsMore
 cmp eax,Y.N10jae TsMore
; Here with integer less than ten.
; Positives are one character answers. Result length to be in cx.
 mov V.Dtype,$NullStringinc cx
 test V.Sign,1jnz @F
 add al,'0'mov V.String,al
TsFrom:add V.Dtype,cl
 pop edxpop ebxpop eax
 mov ds,Z.Zonemov si,StackDiret
; Negative one digit is two character answer.
@@:inc cxmov bx,StringOrder('-','0')add bh,al
 mov Wptr(V.String),bxjmp TsFrom

; Here if non-integer or more than one digit.
; ebx is exponent value. eax is mantissa.
TsMore:; ecx to count how many decimal digits it takes to hold the mantissa.
 mov si,Yshape.N10-4; ecx already zero
@@:add si,4inc cxcmp eax,Dptr cs:[si]jae @B
; Will floating point representation be needed?
; It will if digits for the mantissa plus right zeros implied by exponent
; makes too many digits.  Alternatively, it will if value less than a millionth.
; For this decision we assume the number was made when digits=9.
; (Although maybe get away with other cases?)
 mov edx,ebxadd edx,ecxcmp edx,Y.N10jge TsFloat
 cmp edx,-5jl TsFloat
; dx between -5 and 9. Position of point relative to left of mantissa.
; cx digits from mantissa.
; if bx>=0 there will not be a decimal point. Length will be dx (+1 if "-")
; if bx<0 length will be one for point plus max(cx,-bx+1)
 test bx,bxjge TsNoP
; Now set dx to string length.
 mov dx,bxneg dxinc dxcmp dx,cxjge @Fmov dx,cx@@:mov cx,dxinc dx
TsNoP:test V.Sign,1jz @Finc dx@@:
; Now cx digits, dx total. (Maybe bx right '0' pad)
 xchg cx,dxpush eaxcall ResultSpaceDsxchg cx,dx
 mov si,axpop eax
; Here with V. set up and ds:si addressing target space.
 mov Bptr[si],'-'; May get overlaid.
 push sipush dxadd si,dx
; Fill from the right, first with bx zeros
@@:test bx,bxjle @Fdec simov Bptr[si],'0'dec bxjmp @B@@:
FromFloat:
; Here bx is either 0 to mean no point or negative of position from right.
; There are cx digits to go, point along the way, maybe.
; si right of place for right digit.
 cmp cx,ZeroBpjg @FError49Bp@@:
TsLoop:dec simov edx,ebpdiv Y.N10add dl,'0'mov [si],dl
 inc bxjnz @Fdec simov Bptr[si],'.'@@:LoopQ TsLoop
; These are results for caller.
 pop cxpop si
; These were caller's values.
 pop edxpop ebxpop eax
; Note ES was preserved.
 ret

TsFloat:
; ecx is digits of mantissa.
; ebx is signed exponent alone.
 mov Z.MantSize,cx
; Adjust exponent to desired point position.
 add ebx,ecxdec ebx
 push eax
; Separate sign of exponent. (It cannot have become zero.) ax=0 positive.
 z axcmp ebx,ebpjns @Fneg ebxinc ax@@:mov Z.ExpSign,ax
; Deduce digit places for exponent, into dx.
 mov si,Yshape.N10-4z dx
@@:add si,4inc dxcmp ebx,Dptr cs:[si]jb @F
 cmp si,Yshape.N1e9jne @B
@@:
; Setup result place.
; cx mantissa digits, dx exponent digits, three for punctuation, maybe
; another sign.
; Except that decimal point won't happen if it would be just before 'E'.
 LoopQ @Fdec cx@@:inc cx; 1=>0  rest unaltered.
 add cx,dxadd cx,3test V.Sign,1jz @Finc cx@@:
 call ResultSpaceDsmov si,axpop eax
 mov Bptr[si],'-'; May get overlaid.
 push sipush cx; For result to caller.
; Fill in exponent.
 add si,cxmov cx,dxxchg eax,ebx
FpLoop:dec simov edx,ebpdiv Y.N10add dl,'0'mov [si],dl
 LoopQ FpLoop
 mov dh,'+'cmp Z.ExpSign,ZeroBpje @Fmov dh,'-'@@:
 mov dl,'E'dec sidec simov [si],dx
; Back to fill in mantissa.
 mov cx,Z.MantSize
 xax ebxmov bx,cxneg bxinc bx
 jmp FromFloat
; Check exponent range !!

;------------------------------------------------------------------------------
; Some little routines.
;------------------------------------------------------------------------------
; The value is the name of item bx. Load it.
ValueIsName:push sipush dspush ax; cx set to length.
 mov ds,Z.Varsmov si,Vbx.Heremov ds,Z.Symbols
; ds:si now addresses "counted string" form of name.
 movzx cx,Bptr[si]inc sicmp cl,7ja VINlong
 add cl,$NullStringMove V,Vsid,eaxmov V.Dtype,cljmp @F
VINlong:call VasDsSiCx
@@:pop axpop dsRetSi

BxConst:
; We can deduce the value from bx but it would have been better to do this
; at an earlier stage.
 mov ds,Z.Constsmov si,Vbx.Heremov ds,Z.Symbols
; ds:si now addresses "counted string" form of name.
 movzx cx,Bptr[si]inc sicmp cl,7ja Extlong
 add cl,$NullStringMove V,Vsid,eaxmov V.Dtype,cljmp @F
Extlong:call VasDsSiCx
@@:ret

ResultSpace:; Sets V up as result to address CX bytes. Return also es:ax
 cmp cx,7ja @F
; Setup for short string.
 mov V.Dtype,$NullStringadd V.Dtype,clmv es,sslea ax,V.Stringret
@@:call AllocateCx_EsAx
AwayEsAxCx:; This entry point also used just to set up V.
 mov V.Dtype,$AwayStringmov V.Sg,esmov V.Pt,ax
 mov V.Len,cx
 ret

HeritageDi:; Copies as necessary to inherit from caller.
; Worth the fiddle to avoid caller push.
 pop bppush StackDipush bpxor bp,bp
 mov LevelDi,Z.Level
; MASM error ..............................
HeritRecurse:bts L.Access,InheritDonejc HeritageRet
 push LevelDimov LevelDi,L.UpLevelcall HeritRecursepop LevelDi
; Copy from higher level, known to be already filled.
 push LevelDipush simov LevelSi,L.UpLevellea si,Lsi.Digits
 Assert (Lshape.Inherit-Lshape.Digits) mod 4 eq 0
 push cxmov cx,(Lshape.Inherit-Lshape.Digits)/4lea di,L.Digits
 push esmov es,Z.Zonerep movsd [di],es:[si]pop espop cxpop sipop LevelDi
HeritageRet:ret

comment~ ToDsSiCx is used all over the place so it is worth an effort to
avoid it altering Es.  We need to do the AllocateEsAx in ResultSpace
though, when a numeric input converts to a long string.
~
ResultSpaceDs:mov Z.EsNew,escall ResultSpacemv ds,esmov es,Z.EsNew
; Most times this is simple save/restore of ES but it will also work if
; ES is addressing a segment that compaction moved.
 ret

Version db "REXX 5.00 22 April 99"
Configuration db "DosCrx1.0 "
COMMAND db "COMMAND "; HowInvoked
FUNCTION db "FUNCTION "; HowInvoked
SUBROUTINE db "SUBROUTINE "; HowInvoked
 end
